/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: AffectedStateVariablesClass.h
 *
 *      Authors: Jay M. Doyle, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

// AffectedStateVariablesClass :  Returned by  ListOfStateVariables(char*, char*) method in
//    BaseModelClass
// Jay M. Doyle
// January 18, 1998


#ifndef AFFECTED_STATE_VARIABLES_CLASS_H_
#define AFFECTED_STATE_VARIABLES_CLASS_H_

#include "BaseStateVariableClass.h"

class BaseModelClass;

class AffectedStateVariablesClass {

public:

	///
	BaseStateVariableClass** StateVariablePointerArray;
	///
	BaseModelClass** ModelArray;
	///
	int ArraySize;
	///
	int CurrentElement;

	///
	AffectedStateVariablesClass();
	///
	AffectedStateVariablesClass(int);
	///
	BaseStateVariableClass* Variable(int);
	///
	BaseModelClass* Model(int);
	///
	void appendClass(AffectedStateVariablesClass);

}; // end class AffectedStateVariableClass

#endif // end AFFECTED_STATE_VARIABLES_CLASS_H_
