/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: BaseActionClass.h
 *
 *      Authors: Jay M. Doyle, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef BASESYNCACTIONCLASS_H_
#define BASESYNCACTIONCLASS_H_

#include "BaseStateVariableClass.h"
#include "List.h"
#include "StandardErrors.h"
#include "BaseActionClass.h"
#include "MobiusEnums.h"
#include "../Composer/BaseComposerClass.h"
#include "BaseGroupClass.h"
#include "../Simulator/UserDistributions.h"
#include <stdlib.h>
#include <iostream>
#include "debug.h"
#include "assert.h"

/**
 * This is a link to the distribution archive or possibly to a user
 * defined probability distribution function.
 */
class BaseSyncActionClass: public BaseGroupClass {

	// public methods
public:
	BaseSyncActionClass(char *, int, char**, int*, BaseComposerClass*);
	~BaseSyncActionClass();

	bool NewEnabled, OldEnabled;

	SyncError ErrorMessages;

	inline BaseActionClass** getSuperposedActionList() {
		return (SuperposedActionList);
	}
	;
	inline int getNumSuperposedActions() {
		return (NumSuperposedActions);
	}
	;
	inline BaseActionClass* getSuperposedAction(int i) {
		return (SuperposedActionList[i]);
	}
	;

	bool isSync() {
		return true;
	}

	double SampleDistribution();
	bool Enabled();
	BaseSyncActionClass* Fire();
	double Rate();
	double Weight();
	double Probability(BaseActionClass*);
	int Rank();

	// hier ist mein Zeug
	/////////////////////////////////////////////
	BaseActionClass** SuperposedActionList;
	int NumSuperposedActions;
	///////////////////////////////////////

}; // end BaseSyncActionClass
#endif // BASESYNCACTIONCLASS_H_
