/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: EVUtil
 *
 *      Authors: Tod Courtney Daniel D. Deavours, William H. Sanders
 *      Creation Date: 2004
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef _EV_UTIL_H_
#define _EV_UTIL_H_

class EVUtil {
private:

	int _numKeys;
	int _maxKeys;
	char **_keys;
	char **_values;

	char *Get(const char *key);
	void GetPublicKey();
	void ReadFile(const char *path);
	static char *convertCygwinPathToWindows(char *inpath);

public:
	EVUtil(const char *path);
	~EVUtil();
	bool Check();
	static char *GetDefaultLicenseFilename(char *mobiusroot);

};

#endif
