/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: ListAffectingActionsClass.h
 *
 *      Authors: Jay M. Doyle, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef LIST_AFFECTING_ACTIONS_CLASS
#define LIST_AFFECTING_ACTIONS_CLASS

#include "BaseActionClass.h"

/** This class is returned by the
 *  ListAffectingActions(BaseStateVariableClass*)
 *  contains a array of actions and the size of the array.
 *
 *  @author Jay M. Doyle
 *  @version Mobius Version 1.0
 */
class ListAffectingActionsClass {

public:

	/**
	 */
	BaseActionClass** ActionArray;

	/**
	 */
	int ArraySize;

	/**
	 */
	int CurrentElement;

	/**
	 */
	ListAffectingActionsClass();

	/**
	 */
	ListAffectingActionsClass(int);

	/**
	 */
	BaseActionClass* Action(int);

	/**
	 */
	void appendClass(ListAffectingActionsClass);

}; // end ListAffectingActionsClass

#endif // end LIST_AFFECTING_ACTIONS_CLASS
