/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: MobiusStructs.h
 *
 *      Authors: Jay M. Doyle, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#include "./BaseStateVariableClass.h"

#ifndef MOBIUS_STRUCTS_H_
#define MOBIUS_STRUCTS_H_

/** These specific structs For mobius base classes
 *  @author Jay M. Doyle
 *  @version Mobius Version 1.0
 */

// Forward Declaration
class BaseStateVariableClass;
class BaseModelClass;

/**
 *  This struct is used to save information provided
 *  by the BaseModelClass method listSVs which must
 *  return a List of state variables and the models
 *  in which they are defined.
 */
struct SVStruct {

	/**
	 * A state variable
	 */
	BaseStateVariableClass* TheSV;

	/**
	 * The model in which TheSV is located
	 */
	BaseModelClass* TheModel;

}; // end SVStruct


#endif // MOBIUS_STRUCT_H_
