/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: MobiusUnions.h
 *
 *      Authors: Jay M. Doyle, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef MOBIUS_UNION_H_
#define MOBIUS_UNION_H_

/* These specific unions For mobius base classes
 * @author Jay M. Doyle
 * @version Mobius Version 1.0
 */

/**  This data structure can have an array of pointer of
 *  different types
 */
union ArrayPointerType {
	///
	short** ShortPointer;
	///
	int** IntPointer;
	///
	char** CharPointer;
	///
	double** DoublePointer;
	///
	float** FloatPointer;
	///
	ArrayStateVariable* ArrayPointer;
	///
	StructStateVariable* StructPointer;
	///
	UnorderedStateVariable* UnorderedPointer;
}; // end ArrayPointerType

/** This data structure can contain pointer of several
 * different types
 */
union StructPointerType {
	short* ShortPointer;
	int* IntPointer;
	char* CharPointer;
	double* DoublePointer;
	float* FloatPointer;
}; // end ArrayPointerType


#endif // MOBIUS_UNION_H_
