/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: PEPAVariable.h
 *
 *      Authors: Graham Clark, Jay M. Doyle, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 2000
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef PEPAVARIABLE_H_
#define PEPAVARIABLE_H_

#include "../state/SharableSV.h"
#include "../StandardErrors.h"
#include "../debug.h"
#include <iostream>

/** This class describes the base state variable class for PEPA models
 *
 *   @author Graham Clark
 *   @version Mobius version 1.0 Development
 */
class PEPAVariable: public SharableSV<short> {

public:

	PEPAVariable();

	explicit PEPAVariable(char* TheVariableName);

	PEPAVariable(char* ThePlaceName, short TheInitialMarking);

	inline short& Value() {
		return *TheValue;
	}

	short getValue();

	void setValue(short TheNewValue);

	//void  test();

protected:

	short* TheValue;

};

#endif

