/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef State_H_
#define State_H_

#include <stdio.h>

class BaseModelClass;

class State {
public:
	virtual int hash() {
		return 1;
	}
	virtual int compare(State const & /* S */) const {
		return 1;
	}
	virtual void print() = 0;
	virtual int fwriteState(FILE* f) = 0;
	virtual int freadState(FILE* f) = 0;
	virtual State const & operator=(State const &S) = 0;
	virtual ~State() {
	}
	// protected:
	virtual void SetState(const BaseModelClass* model2) = 0;
	virtual void GetState(const BaseModelClass* model2) = 0;

	// Added for symmetry detection, to efficiently get state
	// Assumes state can be given as a flat array
	virtual void* GetStatePtr() = 0;
};

#endif //State_H_
