/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef TRACE_FILE_MOBIUS_SSG
#define TRACE_FILE_MOBIUS_SSG

#include "TraceFile.h"

class TraceFileMobiusSSG: public TraceFile {
public:
	TraceFileMobiusSSG();
	TraceFileMobiusSSG(const char* fname);
	TraceFileMobiusSSG(std::ostream * stream);

	// access methods, printf, etc
	void printHeader(PVModel* ThePVModel) override;
	void printFooter() override;
	void printState();
	void printInitialState(BaseModelClass* TheModel, BaseStudyClass* theStudy) override;
	void printState(BaseModelClass* TheModel) override;
	void printState(PVModel* PVmodel) override;
	void printFireAction(BaseActionClass* CurrAction, double CurrentTime) override;
	void printPreFireAction(BaseActionClass* CurrAction) override;
	void printPostFireAction(BaseActionClass* CurrAction, BaseActionClass* TempAction) override;
	void newBatch() override;
	void printStr(int level, char * str) override;

};

#endif TRACE_FILE_MOBIUS_SSG
