/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2011 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

/**
 * @file AdversaryDecision.h
 * This file contains the AdversaryDecision class which is a Mobius action.
 */

#ifndef ADVERSARYDECISION_H_
#define ADVERSARYDECISION_H_

#include "BaseADVISEAction.h"

/**
 * The AdversaryDecision class is a Mobius action that represents the adversary deciding to choose a specific attack step.
 */
class AdversaryDecision : public BaseADVISEAction {
public:
	/**
	 * Constructor
	 */
	AdversaryDecision();
	/**
	 * Destructor
	 */
	virtual ~AdversaryDecision();
};

#endif /* ADVERSARYDECISION_H_ */
