/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2011 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

/**
 * @file BeginAdversaryDecision.h
 * This file contains the BeginAdversaryDecision class.
 */

#ifndef BEGINADVERSARYDECISION_H_
#define BEGINADVERSARYDECISION_H_

#include "ADVISEStateVariable.h"
/**
 * The BeginAdversaryDecision class is an ADVISE state variable is marked in order to begin the Adversary Decision action.
 */
class BeginAdversaryDecision: public ADVISEStateVariable<short> {
public:
	/**
	 * Constructor
	 */
	BeginAdversaryDecision();
	/**
	 * Constructor
	 * @param[in] theName The begin adversary decision name
	 */
	BeginAdversaryDecision(char *theName);
	/**
	 * Constructor
	 * @param[in] theName The begin adversary decision name
	 * @param[in] initValue The initial value
	 */
	BeginAdversaryDecision(char *theName, short initValue);
	/**
	 * Destructor
	 */
	virtual ~BeginAdversaryDecision();
};

#endif /* BEGINADVERSARYDECISION_H_ */
