/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2011 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

/**
 * @file Knowledge.h
 * This file contains the Knowledge class which is a Mobius state variable.
 */
#ifndef KNOWLEDGE_H_
#define KNOWLEDGE_H_

#include "ADVISEStateVariable.h"
/**
 * The Knowledge class represents the Knowledge state variable.
 */
class Knowledge : public ADVISEStateVariable<short> {
public:
	/**
	 * Constructor
	 */
	Knowledge();
	/**
	 * Constructor
	 * @param[in] theName The Knowledge name
	 */
	explicit Knowledge(char *theName);
	/**
	 * Constructor
	 * @param[in] theName The Knowledge name
	 * @param[in] initialValue The initial value of the knowledge
	 */
	Knowledge(char *theName, short initialValue);

	Knowledge(const Knowledge&) = delete;
	Knowledge& operator=(const Knowledge&) = delete;

	/**
	 * Destructor
	 */
	virtual ~Knowledge();
};

#endif /* KNOWLEDGE_H_ */
