/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2011 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

/**
 * @file Skill.h
 * This file contains the Skill class which is a Mobius state variable.
 */
#ifndef SKILL_H_
#define SKILL_H_

#include "ADVISEStateVariable.h"
/**
 * The Skill class represents the Skill state variable
 */
class Skill : public ADVISEStateVariable<short> {
public:
	/**
	 * Constructor
	 */
	Skill();
	/**
	 * Constructor
	 * @param[in] theName The name of the skill
	 */
	explicit Skill(char *theName);
	/**
	 * Constructor
	 * @param[in] theName The name of the skill
	 * @param[in] initialValue The initial value of the skill
	 */
	Skill(char *theName, short initialValue);

	Skill(const Skill&) = delete;
	Skill& operator=(const Skill&) = delete;

	/**
	 * Destructor
	 */
	virtual ~Skill();
};

#endif /* SKILL_H_ */
