/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __BASEPVMTMDD_H_
#define __BASEPVMTMDD_H_
#include "mddnode.h"
#include "ssnode.h"
#include "cache.h"

typedef double REAL;

class MTMDDNode: public BaseMDDNode<REAL> {
public:
	MTMDDNode() {
	}
	;
	MTMDDNode(REAL val) :
		BaseMDDNode<REAL> (val) {
	}
	;
	MTMDDNode(short variable, short _size) :
		BaseMDDNode<REAL> (variable, _size) {
	}
	;
	MTMDDNode* getPointer(unsigned short i) const;
};

class BasePVMTMDD {
public:
	~BasePVMTMDD(); //both
	vector<pair<MTMDDNode*, char*> > PVMDDs; //both

protected:
	MTMDDNode* insertNodeUnique(MTMDDNode* node); //both
	pair<MTMDDNode*, bool> findOrAddNode(MTMDDNode* node); //both
	void SetupUniqueTable();
	void EnableGC() {
		GCEnabled = true;
	} //both
	void DisableGC() {
		GCEnabled = false;
	} //both

	NodeUniqueTable<MTMDDNode> UniqueTable; //both
	int MAXLOADFACTOR; //both
	float MAXDEAD; //both
	bool GCEnabled; //both
};

#endif
