/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#include "DynamicObjects.h"
#include <queue>

class ChangedSet {
public:
	ChangedSet(int _size) {
		changed = new DynamicArray<int, true> (_size, false);
	}
	~ChangedSet() {
		delete changed;
	}
	void add(int i);
	int pop();
	bool empty() {
		return changed_set.empty();
	}
	int size() {
		return changed->getSize();
	}
private:
	DynamicArray<int, true>* changed;
	std::queue<int> changed_set;
};
