/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __MATRIXELEMENT_LIST_H__
#define __MATRIXELEMENT_LIST_H__

#include <list>
#include <iostream>
#include "mdnode.h"

using namespace std;

class MatrixElementList {
	friend ostream& operator<<(ostream&, const MatrixElementList&);
	friend istream& operator>>(istream&, MatrixElementList&);
public:
	MatrixElementList();
	void operator+=(const MatrixElementList&);
	void operator+=(const pair<void*, double>&);
	bool operator==(const MatrixElementList&) const;
	bool operator<(const MatrixElementList&) const;
	bool isZero() const;
	void Zero();
	void WriteToMxDNode(MDNode* mdnode, int i) const;
private:
	typedef list<pair<void*, double> >::iterator iterator;
	typedef list<pair<void*, double> >::const_iterator const_iterator;
	list<pair<void*, double> > value;
};

#endif
