/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __VISUALIZE_H_
#define __VISUALIZE_H_
#include "ssnode.h"
#include <set>

class Visualize {
public:
	Visualize(SSNode* _root, const string& _filename);
	void Run();
private:
	void WriteNodes();
	void WriteEdges(SSNode* r);
	void DepthFirstSearch(SSNode* r);
	SSNode* root;
	string outfilename;
	FILE* outfile;
	set<SSNode*> tagged_set;
};

#endif
