/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __VISUALIZE_PVMTMDD_H_
#define __VISUALIZE_PVMTMDD_H_
#include "BasePVMTMDD.h"
#include <set>

class VisualizePVMTMDD {
public:
	VisualizePVMTMDD(MTMDDNode* _root, const string& _filename);
	void Run();
private:
	void WriteNodes();
	void WriteEdges(MTMDDNode* r);
	void DepthFirstSearch(MTMDDNode* r);
	MTMDDNode* root;
	string outfilename;
	FILE* outfile;
	set<MTMDDNode*> tagged_set;
};

#endif
