/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#include <iostream>
#include <vector>
#include "SchreierSimsPermutation.h"
#include "Permutation.h"

using namespace std;
#ifndef SCHREIER_SIMS_H
#define SCHREIER_SIMS_H

class SchreierSims {
public:
	SchreierSims();
	SchreierSims(int n, int num_gens);
	void output();
	int SmallestPointMovedBy(SchreierSimsPermutation h);
	int FirstBasePointMovedBy(SchreierSimsPermutation h);
	void SchreierTree(int alpha, int i);
	bool Sifting(SchreierSimsPermutation h);
	void RunSchreierSims();
	vector<Permutation> Go(vector<Permutation> PermVec, vector<int> & bases);

	int n; // size of omega = {1, ,n}

	SchreierSimsPermutation undefined;
	SchreierSimsPermutation identity;

	int cosreps; // number of    (= size of orbit of alpha)
	SchreierSimsPermutation cosrep[maxn];
	SchreierSimsPermutation csrep[maxn]; // a copy of these
	int firstbasepoint;
	int basepoints;
	int* basepoint;
	int sgss;
	SchreierSimsPermutation* sgs;
	SchreierSimsPermutation gen;

};

#endif
