/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: SharedStateVarLink.h
 *
 *      Authors: Aaron Stillman, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef SHARED_STATE_VAR_LINK_H
#define SHARED_STATE_VAR_LINK_H

#include "../BaseClasses/BaseModelClass.h"

class SharedStateVarLink {
public:
	SharedStateVarLink();
	explicit SharedStateVarLink(BaseStateVariableClass *);
	SharedStateVarLink(BaseStateVariableClass *, BaseModelClass* parent);

	BaseStateVariableClass * myStateVar;
	BaseModelClass * parent;
	SharedStateVarLink * next;

	BaseStateVariableClass * getStateVar() {
		return myStateVar;
	}

	SharedStateVarLink * getNext() {
		return next;
	}

	bool hasStateVar(BaseStateVariableClass *);
	void addStateVarLink(SharedStateVarLink *);
	static void clearStateVarList(SharedStateVarLink*);
	void printAllStateVariables();
};

#endif
