/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: InstantOfTimeImpulse.hpp
 *
 *      Authors: Gerard P. Kavanaugh, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef INSTANT_OF_TIME_IMPULSE_HPP_
#define INSTANT_OF_TIME_IMPULSE_HPP_

#include "ImpulseNodeClass.hpp"
#include "../BaseClasses/BaseActionClass.h"

class InstantOfTimeImpulse: public ImpulseNodeClass {
public:
	//  void BeginAccumulate(double,double);
	void Accumulate(double, double);
	//  void EndAccumulate(double,double);
	void CurrentImpulse(void);
	void completeAccumulation(double);
	void Reset(void);
	InstantOfTimeImpulse();
	~InstantOfTimeImpulse();
};

#endif //INSTANT_OF_TIME_IMPULSE_HPP_
