/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: SteadyState.hpp
 *
 *      Authors: Gerard P. Kavanaugh, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef STEADY_STATE_HPP_
#define STEADY_STATE_HPP_

#include "../BaseClasses/BaseActionClass.h"
#include "IntervalOfTime.hpp"

class SteadyState: public IntervalOfTime {
protected:
public:
	void Accumulate(double new_time, double last_event_time);
	void CurrentReward();
	void Reset(void);
	SteadyState(void);
	~SteadyState(void);
};

#endif //STEADY_STATE_HPP_
