/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: MersenneTwister.h
 *
 *      Authors: Eric Rozier
 *      Creation Date: 2011
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef MERSENNE_TWISTER_H
#define MERSENNE_TWISTER_H

#include "RandomNumberGenerator.h"

#define MT_N 624 // size of the state vector

class MersenneTwister: public RandomNumberGenerator {
 public:
  MersenneTwister();
  // Constructor
  ~MersenneTwister();
  // Destructor

  double rnd() override;
  void srnd(unsigned long) override;

 private:
  unsigned long getMatrixA(unsigned long x);
  unsigned long rnd_int32(); // integer generation
  unsigned long stateVector[MT_N]; // State vector
  bool sVInit; // Has the state vector been initialized?
  int sVIdx; // State vector index

};

#endif // MERSENNETWISTER_H
