/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: RandomNumberGenerator.h
 *
 *      Authors: Alex Williamson, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef RANDOM_NUMBER_GENERATOR
#define RANDOM_NUMBER_GENERATOR

/**
 * Base class from random number generators.
 *
 * @author Alex Williamson
 * @version Mobius v 1.0
 */
class RandomNumberGenerator {
public:
	RandomNumberGenerator()=default;
	virtual ~RandomNumberGenerator()=default;

	/**
	 * Get next random number.
	 * @return double Next random number.
	 */
	virtual double rnd();
	/**
	 * Seed the random number generator
	 * @param long The seed.
	 */
	virtual void srnd(unsigned long);

};

#endif
