/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: Tausworthe.h
 *
 *      Authors: Alex Williamson, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef TAUSWORTHE_H
#define TAUSWORTHE_H

#include "RandomNumberGenerator.h"

/**
 * Class derived from RandomNumberGenerator to implement the
 * Tausworth random number genertor.  See RandomNumberGenerator for
 * method descriptions.
 * @see RandomNumberGenerator
 *
 * @author Alex Williamson
 * @version Mobius v 1.0
 */
class Tausworthe: public RandomNumberGenerator {
public:
	Tausworthe()=default;
	~Tausworthe()=default;

	double rnd() override;
	void srnd(unsigned long) override;

	unsigned long seed;
};

#endif // end TAUSWORTHE_H
