/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: UserDistributions.h
 *
 *      Authors: Alex Williamson, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef USERDISTRIBUTIONS
#define USERDISTRIBUTIONS

#include "Distributions.h"
#include "RandomNumberGenerator.h"
#include "../BaseClasses/StandardErrors.h"
#include "../BaseClasses/debug.h"
#include <iostream>

/**
 * Derived distribution class.  See Distributions for method descriptions.
 * @see Distributions
 *
 * @author Alex Williamson
 * @version Mobius v 1.0
 */
class UserDistributions: public Distributions {
public:
	UserDistributions();
	/**
	 * Constructor which specifies the random number generator and seed.
	 * @param int The generator: 0 = LaggedFibonacci, 1 = Tausworthe
	 * @param long The random number seed.
	 */
	UserDistributions(int, long);
	~UserDistributions();

};
#endif
