/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __PVMTMDDREADER_H_
#define __PVMTMDDREADER_H_
#include "BaseClasses/symbolic/BasePVMTMDD.h"
#include <map>

using namespace std;

class PVMTMDDReader: public BasePVMTMDD {
public:
	PVMTMDDReader(const char* filename); //reader
	PVMTMDDReader(FILE* f);
	~PVMTMDDReader();
	bool readTree(FILE* f); //reader
	int getIOStatus() {
		return IOStatus;
	}

	static const int NoError;
	static const int Error;
private:
	typedef map<int, MTMDDNode*> TNodesMapping; //reader
	int IOStatus;

	void ReadPVMTMDD(FILE* f);
	MTMDDNode* dfsReadTree(FILE* f, TNodesMapping& nodetable); //reader
	void setIOStatus(int _IOStatus) {
		IOStatus = _IOStatus;
	}
};

#endif
