/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: Lumping.h
 *
 *      Authors: Salem Derisavi, William H. Sanders
 *      Creation Date: 2002
 *
 *      Copyright (c) 1994-2003 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/
#ifndef __STATE_LEVEL_LUMPING_H__
#define __STATE_LEVEL_LUMPING_H__

#include <list>

#include "StateLevelObjects/BaseStateLevel.h"
#include "BaseClasses/symbolic/lumping-tarjan.h"
#include "MatrixElementReal.h"
#include "LumpingMain.h"

typedef Lumping<double, MatrixElementReal>::TPartition TPartition;
typedef Lumping<double, MatrixElementReal>::TState TState;

using namespace std;

void ReadCTMC(int argc, char** argv);
int InitializeP();
void Lump();
void ComputeSumsToSplitter(list<int>& S, queue<int>& x_list);
void write_output();
void write_block(ofstream &outfile, TPartition::iterator &src_block);

extern TPartition P;

#endif
