/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: LumpingMain.h
 *
 *      Authors: Salem Derisavi, William H. Sanders
 *      Creation Date: 2002
 *
 *      Copyright (c) 1994-2003 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/
#ifndef __LUMPING_MAIN_H__
#define __LUMPING_MAIN_H__

#include <string.h>

#include "StateLevelObjects/BaseStateLevel.h"
#include "InitialPartition.h"

bool ProcessCommandLine(int argc, char** argv);
void ShowCmdLineOptions();
void Destructor();

extern BaseStateLevel* model;
extern OrdinaryInitialPartition* OrdInitialPartition;
extern vector<int> PVIndices;
extern BaseStateLevel::EdgeBaseIterator* it_col, *it_row;
extern BaseStateLevel::EdgeBaseContainer *col, *row;

extern int verbosity;
extern FILE* fout;

extern char* ssg_full_path;
extern char* output_experiment_name;
extern string comments_filename;

#endif
