/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __MATRIXELEMENT_REAL_H__
#define __MATRIXELEMENT_REAL_H__

#include <iostream>

using namespace std;

class MatrixElementReal {
	friend ostream& operator<<(ostream&, const MatrixElementReal&);
	friend istream& operator>>(istream&, MatrixElementReal&);
public:
	MatrixElementReal();
	MatrixElementReal(double _value);
	void operator+=(const MatrixElementReal&);
	bool operator==(const MatrixElementReal&) const;
	bool operator<(const MatrixElementReal&) const;
	bool isZero() const;
	void Zero();
private:
	double value;
};

#endif
