/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: Reward.h
 *
 *      Authors: John Sowder, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

// This is the reward class header file
#ifndef REWARD_H
#define REWARD_H
#include "../Performance_Variables/PVModel.hpp"

/** Reward class
 * Version 1.0
 * John Sowder
 * 8-6-98
 * This class uses the PV model to get the reward and ouput it to a file
 */

class Reward {

private:
	PVModel *The_Model;
	/** The filetype, binary and ASCII matter for the reward file
	 */
	short filecode;
	unsigned long i;

public:
	Reward() {
	}
	;
	Reward(PVModel *Model, short filetype, char *rewfilename);
	~Reward() {
	}
	;
	/** Get reward from PV model and write it to a file
	 */
	void Calculate(unsigned long);

};

#endif
