/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#include <vector>

#ifndef ATOMIC_MODEL_H
#define ATOMIC_MODEL_H

#include "BaseClasses/BaseModelClass.h"
#include "BaseClasses/BaseActionClass.h"

class GraphAtomicModel {
public:
	GraphAtomicModel(BaseModelClass* _model);
	~GraphAtomicModel();

	BaseModelClass* model;
	base_action_list_t LocalExpActions;
	base_action_list_t LocalImmActions;
	base_action_list_t GlobalActions;

	int* DepLevels;

	/** Vector holding the 'depencies' for each atomic model.
	 *
	 * Used to copy portions of the MDD and state for
	 * firing global actions.
	 */
	vector<BaseModelClass*> DepList;
	int GetNumDependencies();
	int* GetDependencyLevels();
};

#endif
