/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef _UTILS_H_
#define _UTILS_H_

#include "BaseClasses/symbolic/ssnode.h"
#include "BaseClasses/symbolic/mdnode.h"
#include "BaseClasses/symbolic/MappedMDD.h"
#include "PVMTMDDCreator.h"

using namespace std;

typedef enum {
	SSfile, Vizfile, invalid
} TFileType;

void WriteMDFile(MDNode* root, string& filename);
void WriteSSFile(SSNode* root, string& ss_filename);
void WriteVizFile(SSNode* root, string& viz_filename);
void WriteMappingMDDFile(MappingNode* root, string& mapping_filename);
void WriteMTMDDFile(PVMTMDDCreator* mtmdd, string& pv_filename);
TFileType getFileType(char* pathname);
bool file_exists(char* filename);
void FormatNumber(string& str, long long int num);

#endif
