/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __PVMTMDDCREATOR_H_
#define __PVMTMDDCREATOR_H_
#include "BaseClasses/symbolic/BasePVMTMDD.h"
#include <map>
#include "SymDS.h"
#include "Performance_Variables/PVModel.hpp"

class SymbolicSSG;

class PVMTMDDCreator: public BasePVMTMDD {
public:
	PVMTMDDCreator(SymbolicSSG *ssg, int _report_period); //writer
	~PVMTMDDCreator() {
	}
	; //both
	void Compute(SSNode* S, bool _CompLumped); //writer
	void writeTree(FILE* f); //writer

private:
	typedef map<REAL, MTMDDNode*> TLeavesMapping; //writer

	MTMDDNode* ComputeRecurse(SSNode* ssnode); //writer

	TLeavesMapping leaves; //writer
	SymbolicSSG* ssg; //writer
	SymDS* System; //writer
	PerformanceVariableNode* PV; //writer
	int no_of_levels; //writer
	bool CompLumped;
	INDEX_TYPE state_counter; //writer
	int pv_counter;
	int report_period; //writer

	BaseModelClass** models;
	vector<State*>* SSVector;
};

#endif
