#ifndef ConsumeWidgetsPEPA_H_
#define ConsumeWidgetsPEPA_H_

#include <math.h>
#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/PEPA/PEPAModel.h" 
#include "Cpp/BaseClasses/PEPA/PEPAVariable.h"
extern double RecoverRate;
extern UserDistributions* TheDistribution;

void MemoryError();

static double fr_PEPALocal = 0.01;
static double ar_PEPALocal = 4.5;
static double br_PEPALocal = 4.0;
static double inftyIdentifier_PEPALocal = 1e6;

/*********************************************************************
               ConsumeWidgetsPEPA Submodel Definition                   
*********************************************************************/

class ConsumeWidgetsPEPA:public PEPAModel{
public:

class outa_12isouta_22isouta_Act:public PEPAActivity{
public:

PEPAVariable *PEPAComponent0;
short *PEPAComponent0_Mobius_Value;
PEPAVariable *PEPAComponent1;
short *PEPAComponent1_Mobius_Value;

PEPAVariable *b;
short *b_Mobius_Value;
PEPAVariable *a;
short *a_Mobius_Value;

double* TheDistributionParameters;
outa_12isouta_22isouta_Act();
 void LinkVariables();
 inline bool GuardSatisfied();
 double SampleDistribution();
 bool OutputActivitiesDontClash();
 BaseActionClass* Fire();
 double Rate();
};

class outb_Act:public PEPAActivity{
public:

PEPAVariable *PEPAComponent0;
short *PEPAComponent0_Mobius_Value;

PEPAVariable *b;
short *b_Mobius_Value;
PEPAVariable *a;
short *a_Mobius_Value;

double* TheDistributionParameters;
outb_Act();
 void LinkVariables();
 inline bool GuardSatisfied();
 double SampleDistribution();
 bool OutputActivitiesDontClash();
 BaseActionClass* Fire();
 double Rate();
};

class recover_Act:public PEPAActivity{
public:

PEPAVariable *PEPAComponent1;
short *PEPAComponent1_Mobius_Value;


double* TheDistributionParameters;
recover_Act();
 void LinkVariables();
 inline bool GuardSatisfied();
 double SampleDistribution();
 bool OutputActivitiesDontClash();
 BaseActionClass* Fire();
 double Rate();
};

class fail_Act:public PEPAActivity{
public:

PEPAVariable *PEPAComponent1;
short *PEPAComponent1_Mobius_Value;


double* TheDistributionParameters;
fail_Act();
 void LinkVariables();
 inline bool GuardSatisfied();
 double SampleDistribution();
 bool OutputActivitiesDontClash();
 BaseActionClass* Fire();
 double Rate();
};

// List of user-specified variable names

PEPAVariable *PEPAComponent0;
PEPAVariable *PEPAComponent1;

PEPAVariable *b;
PEPAVariable *a;

// Create instances of all activities

outa_12isouta_22isouta_Act outa_12isouta_22isouta;
outb_Act outb;
recover_Act recover;
fail_Act fail;

// Create instances of all groups 


ConsumeWidgetsPEPA();
~ConsumeWidgetsPEPA(){};

};

#endif // ConsumeWidgetsPEPA_H_
