

// This C++ file was created by SanEditor

#include "Atomic/RobotArm/RobotArmSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         RobotArmSAN Constructor             
******************************************************************/


RobotArmSAN::RobotArmSAN(){


  Activity* InitialActionList[2]={
    &Assemble, //0
    &Arrive  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(Assemble), 
    (BaseGroupClass*) &(Arrive)
  };

  Bin2 = new Place("Bin2" ,0);
  Bin = new Place("Bin" ,0);
  Accumulate = new Place("Accumulate" ,0);
  BaseStateVariableClass* InitialPlaces[3]={
    Bin2,  // 0
    Bin,  // 1
    Accumulate   // 2
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("RobotArm", 3, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[4][2]={ 
    {0,0}, {1,0}, {2,0}, {2,1}
  };
  for(int n=0;n<4;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[4][2]={ 
    {2,0}, {1,0}, {0,0}, {2,1}
  };
  for(int n=0;n<4;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void RobotArmSAN::CustomInitialization() {

}
RobotArmSAN::~RobotArmSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void RobotArmSAN::assignPlacesToActivitiesInst(){
}
void RobotArmSAN::assignPlacesToActivitiesTimed(){
  Assemble.Accumulate = (Place*) LocalStateVariables[2];
  Assemble.Bin = (Place*) LocalStateVariables[1];
  Assemble.Bin2 = (Place*) LocalStateVariables[0];
  Arrive.Accumulate = (Place*) LocalStateVariables[2];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================AssembleActivity========================*/

RobotArmSAN::AssembleActivity::AssembleActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Assemble",0,Exponential, RaceEnabled, 3,3, false);
}

RobotArmSAN::AssembleActivity::~AssembleActivity(){
  delete[] TheDistributionParameters;
}

void RobotArmSAN::AssembleActivity::LinkVariables(){
  Accumulate->Register(&Accumulate_Mobius_Mark);
  Bin->Register(&Bin_Mobius_Mark);
  Bin2->Register(&Bin2_Mobius_Mark);
}

bool RobotArmSAN::AssembleActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Accumulate->Mark() >= ACCMINTOASSEMBLE) &&
(Bin->Mark() < BINSIZE) &&
(Bin2->Mark() < BINSIZE)
));
  return NewEnabled;
}

double RobotArmSAN::AssembleActivity::Rate(){
  return 5;
  return 1.0;  // default rate if none is specified
}

double RobotArmSAN::AssembleActivity::Weight(){ 
  return 1;
}

bool RobotArmSAN::AssembleActivity::ReactivationPredicate(){ 
  return false;
}

bool RobotArmSAN::AssembleActivity::ReactivationFunction(){ 
  return false;
}

double RobotArmSAN::AssembleActivity::SampleDistribution(){
  return TheDistribution->Exponential(5);
}

double* RobotArmSAN::AssembleActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int RobotArmSAN::AssembleActivity::Rank(){
  return 1;
}

BaseActionClass* RobotArmSAN::AssembleActivity::Fire(){
  Accumulate->Mark() -= ACCMINTOASSEMBLE;
  (*(Bin2_Mobius_Mark))++;
  (*(Bin_Mobius_Mark))++;
  return this;
}

/*======================ArriveActivity========================*/

RobotArmSAN::ArriveActivity::ArriveActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Arrive",1,Exponential, RaceEnabled, 1,1, false);
}

RobotArmSAN::ArriveActivity::~ArriveActivity(){
  delete[] TheDistributionParameters;
}

void RobotArmSAN::ArriveActivity::LinkVariables(){
  Accumulate->Register(&Accumulate_Mobius_Mark);
}

bool RobotArmSAN::ArriveActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((Accumulate->Mark() != ACCSIZE));
  return NewEnabled;
}

double RobotArmSAN::ArriveActivity::Rate(){
  return 6;
  return 1.0;  // default rate if none is specified
}

double RobotArmSAN::ArriveActivity::Weight(){ 
  return 1;
}

bool RobotArmSAN::ArriveActivity::ReactivationPredicate(){ 
  return false;
}

bool RobotArmSAN::ArriveActivity::ReactivationFunction(){ 
  return false;
}

double RobotArmSAN::ArriveActivity::SampleDistribution(){
  return TheDistribution->Exponential(6);
}

double* RobotArmSAN::ArriveActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int RobotArmSAN::ArriveActivity::Rank(){
  return 1;
}

BaseActionClass* RobotArmSAN::ArriveActivity::Fire(){
  ;
  (*(Accumulate_Mobius_Mark))++;
  return this;
}

