#ifndef RobotArmSAN_H_
#define RobotArmSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern short ACCSIZE;
extern short ACCMINTOASSEMBLE;
extern short BINSIZE;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               RobotArmSAN Submodel Definition                   
*********************************************************************/

class RobotArmSAN:public SANModel{
public:

class AssembleActivity:public Activity {
public:

  Place* Accumulate;
  short* Accumulate_Mobius_Mark;
  Place* Bin;
  short* Bin_Mobius_Mark;
  Place* Bin2;
  short* Bin2_Mobius_Mark;

  double* TheDistributionParameters;
  AssembleActivity();
  ~AssembleActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // AssembleActivityActivity

class ArriveActivity:public Activity {
public:

  Place* Accumulate;
  short* Accumulate_Mobius_Mark;

  double* TheDistributionParameters;
  ArriveActivity();
  ~ArriveActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // ArriveActivityActivity

  //List of user-specified place names
  Place* Bin2;
  Place* Bin;
  Place* Accumulate;

  // Create instances of all actvities
  AssembleActivity Assemble;
  ArriveActivity Arrive;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  RobotArmSAN();
  ~RobotArmSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end RobotArmSAN

#endif // RobotArmSAN_H_
