#include "Composed/System/SystemRJ.h"
char * SystemRJ__SharedNames[] = {"FirstBin", "SecondBin"};

SystemRJ::SystemRJ():Join("SystemJoin", 2, 2,SystemRJ__SharedNames) {
  Robots = new SystemRJ__Robots();
  ModelArray[0] = (BaseModelClass*) Robots;
  ModelArray[0]->DefineName("Robots");
  Consume = new ConsumeWidgetsPEPA();
  ModelArray[1] = (BaseModelClass*) Consume;
  ModelArray[1]->DefineName("Consume");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    FirstBin = new Place("FirstBin");
    addSharedPtr(FirstBin, "FirstBin" );
    if (Robots->NumStateVariables > 0) {
      FirstBin->ShareWith(Robots->Bin);
      addSharingInfo(Robots->Bin, FirstBin, Robots);
    }
    if (Consume->NumStateVariables > 0) {
      FirstBin->ShareWith(Consume->a);
      addSharingInfo(Consume->a, FirstBin, Consume);
    }

    //Shared variable 1
    SecondBin = new Place("SecondBin");
    addSharedPtr(SecondBin, "SecondBin" );
    if (Robots->NumStateVariables > 0) {
      SecondBin->ShareWith(Robots->Bin2);
      addSharingInfo(Robots->Bin2, SecondBin, Robots);
    }
    if (Consume->NumStateVariables > 0) {
      SecondBin->ShareWith(Consume->b);
      addSharingInfo(Consume->b, SecondBin, Consume);
    }

  }

  Setup();
}

SystemRJ::~SystemRJ() {
  if (!AllChildrenEmpty()) {
    delete FirstBin;
    delete SecondBin;
  }
  delete Robots;
  delete Consume;
}
