#include "Composed/System/SystemRJ__Robots.h"
char * SystemRJ__Robots__SharedNames[] = {"Bin", "Bin2"};

SystemRJ__Robots::SystemRJ__Robots():Rep("Robots", 2, 2, SystemRJ__Robots__SharedNames)
{
  InstanceArray = new RobotArmSAN * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new RobotArmSAN();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    Bin = new Place("Bin");
    addSharedPtr(Bin, "Bin");
    Bin->ShareWith(InstanceArray[0]->Bin);

    Bin2 = new Place("Bin2");
    addSharedPtr(Bin2, "Bin2");
    Bin2->ShareWith(InstanceArray[0]->Bin2);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Bin, Bin);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Bin2, Bin2);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->Bin->ShareWith(InstanceArray[counter]->Bin);
      InstanceArray[0]->Bin2->ShareWith(InstanceArray[counter]->Bin2);
    }
  }
  Setup("Robot");
}

SystemRJ__Robots::~SystemRJ__Robots() {
  if (NumModels == 0) return;
  delete Bin;
  delete Bin2;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

