#include "AvNumInBinsPVNodes.h"

AvNumInBinsPV0Worker::AvNumInBinsPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Consume);
}

AvNumInBinsPV0Worker::~AvNumInBinsPV0Worker() {
  delete [] TheModelPtr;
}

double AvNumInBinsPV0Worker::Reward_Function(void) {

return Consume->a->getValue();


return (0);



}

AvNumInBinsPV0::AvNumInBinsPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSystemRJ);
  double startpts[1]={500.0};
  double stoppts[1]={500.0+3000.0};
  Initialize("AvNumInFirstBin",(RewardType)3,1, startpts, stoppts, timeindex, 0,1, 1);
  Type = steady_state;
  AddVariableDependency("a","Consume");
}

AvNumInBinsPV0::~AvNumInBinsPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void AvNumInBinsPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new AvNumInBinsPV0Worker;
}
AvNumInBinsPV1Worker::AvNumInBinsPV1Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Consume);
}

AvNumInBinsPV1Worker::~AvNumInBinsPV1Worker() {
  delete [] TheModelPtr;
}

double AvNumInBinsPV1Worker::Reward_Function(void) {

return Consume->b->getValue();


return (0);



}

AvNumInBinsPV1::AvNumInBinsPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSystemRJ);
  double startpts[1]={500.0};
  double stoppts[1]={500.0+3000.0};
  Initialize("AvNumInSecondBin",(RewardType)3,1, startpts, stoppts, timeindex, 0,1, 1);
  Type = steady_state;
  AddVariableDependency("b","Consume");
}

AvNumInBinsPV1::~AvNumInBinsPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void AvNumInBinsPV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new AvNumInBinsPV1Worker;
}
