

// This C++ file was created by SanEditor

#include "Atomic/errorhandlers/errorhandlersSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         errorhandlersSAN Constructor             
******************************************************************/


errorhandlersSAN::errorhandlersSAN(){


  Ac_chip_failureGroup.initialize(2, "Ac_chip_failureGroup");
  Ac_chip_failureGroup.appendGroup((BaseGroupClass*) &Ac_chip_failure_case1);
  Ac_chip_failureGroup.appendGroup((BaseGroupClass*) &Ac_chip_failure_case2);

  Activity* InitialActionList[2]={
    &Ac_chip_failure_case1, //0
    &Ac_chip_failure_case2  // 1
  };

  BaseGroupClass* InitialGroupList[1]={
    (BaseGroupClass*) &(Ac_chip_failureGroup)
  };

  cpus = new Place("cpus" ,3);
  computer_failed = new Place("computer_failed" ,0);
  memory_failed = new Place("memory_failed" ,0);
  errorhandlers = new Place("errorhandlers" ,2);
  ioports = new Place("ioports" ,2);
  BaseStateVariableClass* InitialPlaces[5]={
    cpus,  // 0
    computer_failed,  // 1
    memory_failed,  // 2
    errorhandlers,  // 3
    ioports   // 4
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("errorhandlers", 5, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 1, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[10][2]={ 
    {3,0}, {0,0}, {4,0}, {2,0}, {1,0}, {3,1}, {0,1}, {4,1}, {2,1}, 
    {1,1}
  };
  for(int n=0;n<10;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[6][2]={ 
    {3,0}, {2,0}, {1,0}, {3,1}, {2,1}, {1,1}
  };
  for(int n=0;n<6;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void errorhandlersSAN::CustomInitialization() {

}
errorhandlersSAN::~errorhandlersSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void errorhandlersSAN::assignPlacesToActivitiesInst(){
}
void errorhandlersSAN::assignPlacesToActivitiesTimed(){
  Ac_chip_failure_case1.errorhandlers = (Place*) LocalStateVariables[3];
  Ac_chip_failure_case1.memory_failed = (Place*) LocalStateVariables[2];
  Ac_chip_failure_case1.computer_failed = (Place*) LocalStateVariables[1];
  Ac_chip_failure_case1.cpus = (Place*) LocalStateVariables[0];
  Ac_chip_failure_case1.ioports = (Place*) LocalStateVariables[4];
  Ac_chip_failure_case2.errorhandlers = (Place*) LocalStateVariables[3];
  Ac_chip_failure_case2.memory_failed = (Place*) LocalStateVariables[2];
  Ac_chip_failure_case2.computer_failed = (Place*) LocalStateVariables[1];
  Ac_chip_failure_case2.cpus = (Place*) LocalStateVariables[0];
  Ac_chip_failure_case2.ioports = (Place*) LocalStateVariables[4];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Ac_chip_failureActivity_case1========================*/

errorhandlersSAN::Ac_chip_failureActivity_case1::Ac_chip_failureActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_chip_failure_case1",0,Exponential, RaceEnabled, 5,3, true);
}

errorhandlersSAN::Ac_chip_failureActivity_case1::~Ac_chip_failureActivity_case1(){
  delete[] TheDistributionParameters;
}

void errorhandlersSAN::Ac_chip_failureActivity_case1::LinkVariables(){
  errorhandlers->Register(&errorhandlers_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  cpus->Register(&cpus_Mobius_Mark);
  ioports->Register(&ioports_Mobius_Mark);
}

bool errorhandlersSAN::Ac_chip_failureActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((errorhandlers->Mark() == 2) && (memory_failed->Mark() < 2) && 
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double errorhandlersSAN::Ac_chip_failureActivity_case1::Rate(){
  return 0.008766  * errorhandlers->Mark();
  return 1.0;  // default rate if none is specified
}

double errorhandlersSAN::Ac_chip_failureActivity_case1::Weight(){ 
  return comp_cov;
}

bool errorhandlersSAN::Ac_chip_failureActivity_case1::ReactivationPredicate(){ 
  return 1;
}

bool errorhandlersSAN::Ac_chip_failureActivity_case1::ReactivationFunction(){ 
  return 1;
}

double errorhandlersSAN::Ac_chip_failureActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(0.008766  * errorhandlers->Mark());
}

double* errorhandlersSAN::Ac_chip_failureActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int errorhandlersSAN::Ac_chip_failureActivity_case1::Rank(){
  return 1;
}

BaseActionClass* errorhandlersSAN::Ac_chip_failureActivity_case1::Fire(){
  errorhandlers->Mark() = 0;
  cpus->Mark() = 0;
ioports->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark()++;
  return this;
}

/*======================Ac_chip_failureActivity_case2========================*/

errorhandlersSAN::Ac_chip_failureActivity_case2::Ac_chip_failureActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_chip_failure_case2",0,Exponential, RaceEnabled, 5,3, true);
}

errorhandlersSAN::Ac_chip_failureActivity_case2::~Ac_chip_failureActivity_case2(){
  delete[] TheDistributionParameters;
}

void errorhandlersSAN::Ac_chip_failureActivity_case2::LinkVariables(){
  errorhandlers->Register(&errorhandlers_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  cpus->Register(&cpus_Mobius_Mark);
  ioports->Register(&ioports_Mobius_Mark);
}

bool errorhandlersSAN::Ac_chip_failureActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((errorhandlers->Mark() == 2) && (memory_failed->Mark() < 2) && 
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double errorhandlersSAN::Ac_chip_failureActivity_case2::Rate(){
  return 0.008766  * errorhandlers->Mark();
  return 1.0;  // default rate if none is specified
}

double errorhandlersSAN::Ac_chip_failureActivity_case2::Weight(){ 
  return 1.0 - comp_cov;
}

bool errorhandlersSAN::Ac_chip_failureActivity_case2::ReactivationPredicate(){ 
  return 1;
}

bool errorhandlersSAN::Ac_chip_failureActivity_case2::ReactivationFunction(){ 
  return 1;
}

double errorhandlersSAN::Ac_chip_failureActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(0.008766  * errorhandlers->Mark());
}

double* errorhandlersSAN::Ac_chip_failureActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int errorhandlersSAN::Ac_chip_failureActivity_case2::Rank(){
  return 1;
}

BaseActionClass* errorhandlersSAN::Ac_chip_failureActivity_case2::Fire(){
  errorhandlers->Mark() = 0;
  cpus->Mark() = 0;
ioports->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark() = num_comp;
  return this;
}

