#ifndef errorhandlersSAN_H_
#define errorhandlersSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern short num_comp;
extern double comp_cov;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               errorhandlersSAN Submodel Definition                   
*********************************************************************/

class errorhandlersSAN:public SANModel{
public:

class Ac_chip_failureActivity_case1:public Activity {
public:

  Place* errorhandlers;
  short* errorhandlers_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* cpus;
  short* cpus_Mobius_Mark;
  Place* ioports;
  short* ioports_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_chip_failureActivity_case1();
  ~Ac_chip_failureActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_chip_failureActivity_case1Activity

class Ac_chip_failureActivity_case2:public Activity {
public:

  Place* errorhandlers;
  short* errorhandlers_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* cpus;
  short* cpus_Mobius_Mark;
  Place* ioports;
  short* ioports_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_chip_failureActivity_case2();
  ~Ac_chip_failureActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_chip_failureActivity_case2Activity

  //List of user-specified place names
  Place* cpus;
  Place* computer_failed;
  Place* memory_failed;
  Place* errorhandlers;
  Place* ioports;

  // Create instances of all actvities
  Ac_chip_failureActivity_case1 Ac_chip_failure_case1;
  Ac_chip_failureActivity_case2 Ac_chip_failure_case2;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;
  PostselectGroup Ac_chip_failureGroup;
  errorhandlersSAN();
  ~errorhandlersSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end errorhandlersSAN

#endif // errorhandlersSAN_H_
