

// This C++ file was created by SanEditor

#include "Atomic/io_port_module/io_port_moduleSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         io_port_moduleSAN Constructor             
******************************************************************/


io_port_moduleSAN::io_port_moduleSAN(){


  io_port_failureGroup.initialize(3, "io_port_failureGroup");
  io_port_failureGroup.appendGroup((BaseGroupClass*) &io_port_failure_case1);
  io_port_failureGroup.appendGroup((BaseGroupClass*) &io_port_failure_case2);
  io_port_failureGroup.appendGroup((BaseGroupClass*) &io_port_failure_case3);

  Activity* InitialActionList[3]={
    &io_port_failure_case1, //0
    &io_port_failure_case2, //1
    &io_port_failure_case3  // 2
  };

  BaseGroupClass* InitialGroupList[1]={
    (BaseGroupClass*) &(io_port_failureGroup)
  };

  cpus = new Place("cpus" ,3);
  computer_failed = new Place("computer_failed" ,0);
  memory_failed = new Place("memory_failed" ,0);
  errorhandlers = new Place("errorhandlers" ,2);
  ioports = new Place("ioports" ,2);
  BaseStateVariableClass* InitialPlaces[5]={
    cpus,  // 0
    computer_failed,  // 1
    memory_failed,  // 2
    errorhandlers,  // 3
    ioports   // 4
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("io_port_module", 5, InitialPlaces, 
                        0, InitialROPlaces, 
                        3, InitialActionList, 1, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[11][2]={ 
    {4,0}, {0,1}, {4,1}, {3,1}, {2,1}, {1,1}, {0,2}, {4,2}, {3,2}, 
    {2,2}, {1,2}
  };
  for(int n=0;n<11;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[9][2]={ 
    {4,0}, {2,0}, {1,0}, {4,1}, {2,1}, {1,1}, {4,2}, {2,2}, {1,2}
  };
  for(int n=0;n<9;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<3;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void io_port_moduleSAN::CustomInitialization() {

}
io_port_moduleSAN::~io_port_moduleSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void io_port_moduleSAN::assignPlacesToActivitiesInst(){
}
void io_port_moduleSAN::assignPlacesToActivitiesTimed(){
  io_port_failure_case1.ioports = (Place*) LocalStateVariables[4];
  io_port_failure_case1.memory_failed = (Place*) LocalStateVariables[2];
  io_port_failure_case1.computer_failed = (Place*) LocalStateVariables[1];
  io_port_failure_case2.ioports = (Place*) LocalStateVariables[4];
  io_port_failure_case2.memory_failed = (Place*) LocalStateVariables[2];
  io_port_failure_case2.computer_failed = (Place*) LocalStateVariables[1];
  io_port_failure_case2.cpus = (Place*) LocalStateVariables[0];
  io_port_failure_case2.errorhandlers = (Place*) LocalStateVariables[3];
  io_port_failure_case3.ioports = (Place*) LocalStateVariables[4];
  io_port_failure_case3.memory_failed = (Place*) LocalStateVariables[2];
  io_port_failure_case3.computer_failed = (Place*) LocalStateVariables[1];
  io_port_failure_case3.cpus = (Place*) LocalStateVariables[0];
  io_port_failure_case3.errorhandlers = (Place*) LocalStateVariables[3];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================io_port_failureActivity_case1========================*/

io_port_moduleSAN::io_port_failureActivity_case1::io_port_failureActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("io_port_failure_case1",0,Exponential, RaceEnabled, 1,3, true);
}

io_port_moduleSAN::io_port_failureActivity_case1::~io_port_failureActivity_case1(){
  delete[] TheDistributionParameters;
}

void io_port_moduleSAN::io_port_failureActivity_case1::LinkVariables(){
  ioports->Register(&ioports_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
}

bool io_port_moduleSAN::io_port_failureActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((ioports->Mark() > 0) && (memory_failed->Mark() < 2) && 
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double io_port_moduleSAN::io_port_failureActivity_case1::Rate(){
  return 0.0052596 * ioports->Mark();
  return 1.0;  // default rate if none is specified
}

double io_port_moduleSAN::io_port_failureActivity_case1::Weight(){ 
  if (ioports->Mark() == 2)
	return (IO_cov);
else
	return(0.0);
}

bool io_port_moduleSAN::io_port_failureActivity_case1::ReactivationPredicate(){ 
  return 1;
}

bool io_port_moduleSAN::io_port_failureActivity_case1::ReactivationFunction(){ 
  return 1;
}

double io_port_moduleSAN::io_port_failureActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(0.0052596 * ioports->Mark());
}

double* io_port_moduleSAN::io_port_failureActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int io_port_moduleSAN::io_port_failureActivity_case1::Rank(){
  return 1;
}

BaseActionClass* io_port_moduleSAN::io_port_failureActivity_case1::Fire(){
  ;
  if (ioports->Mark() == 2)
	ioports->Mark()--;
  return this;
}

/*======================io_port_failureActivity_case2========================*/

io_port_moduleSAN::io_port_failureActivity_case2::io_port_failureActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("io_port_failure_case2",0,Exponential, RaceEnabled, 5,3, true);
}

io_port_moduleSAN::io_port_failureActivity_case2::~io_port_failureActivity_case2(){
  delete[] TheDistributionParameters;
}

void io_port_moduleSAN::io_port_failureActivity_case2::LinkVariables(){
  ioports->Register(&ioports_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  cpus->Register(&cpus_Mobius_Mark);
  errorhandlers->Register(&errorhandlers_Mobius_Mark);
}

bool io_port_moduleSAN::io_port_failureActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((ioports->Mark() > 0) && (memory_failed->Mark() < 2) && 
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double io_port_moduleSAN::io_port_failureActivity_case2::Rate(){
  return 0.0052596 * ioports->Mark();
  return 1.0;  // default rate if none is specified
}

double io_port_moduleSAN::io_port_failureActivity_case2::Weight(){ 
  if (ioports->Mark() == 2)
	return((1.0 - IO_cov) * comp_cov);
else
	return(comp_cov);
}

bool io_port_moduleSAN::io_port_failureActivity_case2::ReactivationPredicate(){ 
  return 1;
}

bool io_port_moduleSAN::io_port_failureActivity_case2::ReactivationFunction(){ 
  return 1;
}

double io_port_moduleSAN::io_port_failureActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(0.0052596 * ioports->Mark());
}

double* io_port_moduleSAN::io_port_failureActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int io_port_moduleSAN::io_port_failureActivity_case2::Rank(){
  return 1;
}

BaseActionClass* io_port_moduleSAN::io_port_failureActivity_case2::Fire(){
  ;
  cpus->Mark() = 0;
ioports->Mark() = 0;
errorhandlers->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark()++;
  return this;
}

/*======================io_port_failureActivity_case3========================*/

io_port_moduleSAN::io_port_failureActivity_case3::io_port_failureActivity_case3(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("io_port_failure_case3",0,Exponential, RaceEnabled, 5,3, true);
}

io_port_moduleSAN::io_port_failureActivity_case3::~io_port_failureActivity_case3(){
  delete[] TheDistributionParameters;
}

void io_port_moduleSAN::io_port_failureActivity_case3::LinkVariables(){
  ioports->Register(&ioports_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  cpus->Register(&cpus_Mobius_Mark);
  errorhandlers->Register(&errorhandlers_Mobius_Mark);
}

bool io_port_moduleSAN::io_port_failureActivity_case3::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((ioports->Mark() > 0) && (memory_failed->Mark() < 2) && 
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double io_port_moduleSAN::io_port_failureActivity_case3::Rate(){
  return 0.0052596 * ioports->Mark();
  return 1.0;  // default rate if none is specified
}

double io_port_moduleSAN::io_port_failureActivity_case3::Weight(){ 
  if (ioports->Mark() == 2)
	return((1.0 - IO_cov) * (1.0 - comp_cov));
else
	return (1.0 - comp_cov);
}

bool io_port_moduleSAN::io_port_failureActivity_case3::ReactivationPredicate(){ 
  return 1;
}

bool io_port_moduleSAN::io_port_failureActivity_case3::ReactivationFunction(){ 
  return 1;
}

double io_port_moduleSAN::io_port_failureActivity_case3::SampleDistribution(){
  return TheDistribution->Exponential(0.0052596 * ioports->Mark());
}

double* io_port_moduleSAN::io_port_failureActivity_case3::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int io_port_moduleSAN::io_port_failureActivity_case3::Rank(){
  return 1;
}

BaseActionClass* io_port_moduleSAN::io_port_failureActivity_case3::Fire(){
  ;
  cpus->Mark() = 0;
ioports->Mark() = 0;
errorhandlers->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark() = num_comp;
  return this;
}

