#ifndef io_port_moduleSAN_H_
#define io_port_moduleSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double comp_cov;
extern short num_comp;
extern double IO_cov;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               io_port_moduleSAN Submodel Definition                   
*********************************************************************/

class io_port_moduleSAN:public SANModel{
public:

class io_port_failureActivity_case1:public Activity {
public:

  Place* ioports;
  short* ioports_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;

  double* TheDistributionParameters;
  io_port_failureActivity_case1();
  ~io_port_failureActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // io_port_failureActivity_case1Activity

class io_port_failureActivity_case2:public Activity {
public:

  Place* ioports;
  short* ioports_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* cpus;
  short* cpus_Mobius_Mark;
  Place* errorhandlers;
  short* errorhandlers_Mobius_Mark;

  double* TheDistributionParameters;
  io_port_failureActivity_case2();
  ~io_port_failureActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // io_port_failureActivity_case2Activity

class io_port_failureActivity_case3:public Activity {
public:

  Place* ioports;
  short* ioports_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* cpus;
  short* cpus_Mobius_Mark;
  Place* errorhandlers;
  short* errorhandlers_Mobius_Mark;

  double* TheDistributionParameters;
  io_port_failureActivity_case3();
  ~io_port_failureActivity_case3();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // io_port_failureActivity_case3Activity

  //List of user-specified place names
  Place* cpus;
  Place* computer_failed;
  Place* memory_failed;
  Place* errorhandlers;
  Place* ioports;

  // Create instances of all actvities
  io_port_failureActivity_case1 io_port_failure_case1;
  io_port_failureActivity_case2 io_port_failure_case2;
  io_port_failureActivity_case3 io_port_failure_case3;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;
  PostselectGroup io_port_failureGroup;
  io_port_moduleSAN();
  ~io_port_moduleSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end io_port_moduleSAN

#endif // io_port_moduleSAN_H_
