

// This C++ file was created by SanEditor

#include "Atomic/memory_module/memory_moduleSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         memory_moduleSAN Constructor             
******************************************************************/


memory_moduleSAN::memory_moduleSAN(){


  interface_chip_failureGroup.initialize(3, "interface_chip_failureGroup");
  interface_chip_failureGroup.appendGroup((BaseGroupClass*) &interface_chip_failure_case1);
  interface_chip_failureGroup.appendGroup((BaseGroupClass*) &interface_chip_failure_case2);
  interface_chip_failureGroup.appendGroup((BaseGroupClass*) &interface_chip_failure_case3);

  memory_chip_failureGroup.initialize(4, "memory_chip_failureGroup");
  memory_chip_failureGroup.appendGroup((BaseGroupClass*) &memory_chip_failure_case1);
  memory_chip_failureGroup.appendGroup((BaseGroupClass*) &memory_chip_failure_case2);
  memory_chip_failureGroup.appendGroup((BaseGroupClass*) &memory_chip_failure_case3);
  memory_chip_failureGroup.appendGroup((BaseGroupClass*) &memory_chip_failure_case4);

  Activity* InitialActionList[7]={
    &interface_chip_failure_case1, //0
    &interface_chip_failure_case2, //1
    &interface_chip_failure_case3, //2
    &memory_chip_failure_case1, //3
    &memory_chip_failure_case2, //4
    &memory_chip_failure_case3, //5
    &memory_chip_failure_case4  // 6
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(interface_chip_failureGroup), 
    (BaseGroupClass*) &(memory_chip_failureGroup)
  };

  memory_failed = new Place("memory_failed" ,0);
  computer_failed = new Place("computer_failed" ,0);
  interface_chips = new Place("interface_chips" ,2);
  memory_chips = new Place("memory_chips" ,41);
  BaseStateVariableClass* InitialPlaces[4]={
    memory_failed,  // 0
    computer_failed,  // 1
    interface_chips,  // 2
    memory_chips   // 3
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("memory_module", 4, InitialPlaces, 
                        0, InitialROPlaces, 
                        7, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[25][2]={ 
    {3,0}, {2,0}, {0,0}, {1,0}, {3,1}, {2,1}, {0,1}, {1,1}, {3,2}, 
    {2,2}, {0,2}, {1,2}, {3,3}, {3,4}, {2,4}, {0,4}, {1,4}, {3,5}, 
    {2,5}, {0,5}, {1,5}, {3,6}, {2,6}, {0,6}, {1,6}
  };
  for(int n=0;n<25;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[21][2]={ 
    {2,0}, {0,0}, {1,0}, {2,1}, {0,1}, {1,1}, {2,2}, {0,2}, {1,2}, 
    {3,3}, {1,3}, {0,3}, {3,4}, {1,4}, {0,4}, {3,5}, {1,5}, {0,5}, 
    {3,6}, {1,6}, {0,6}
  };
  for(int n=0;n<21;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<7;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void memory_moduleSAN::CustomInitialization() {

}
memory_moduleSAN::~memory_moduleSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void memory_moduleSAN::assignPlacesToActivitiesInst(){
}
void memory_moduleSAN::assignPlacesToActivitiesTimed(){
  interface_chip_failure_case1.interface_chips = (Place*) LocalStateVariables[2];
  interface_chip_failure_case1.memory_failed = (Place*) LocalStateVariables[0];
  interface_chip_failure_case1.computer_failed = (Place*) LocalStateVariables[1];
  interface_chip_failure_case1.memory_chips = (Place*) LocalStateVariables[3];
  interface_chip_failure_case2.interface_chips = (Place*) LocalStateVariables[2];
  interface_chip_failure_case2.memory_failed = (Place*) LocalStateVariables[0];
  interface_chip_failure_case2.computer_failed = (Place*) LocalStateVariables[1];
  interface_chip_failure_case2.memory_chips = (Place*) LocalStateVariables[3];
  interface_chip_failure_case3.interface_chips = (Place*) LocalStateVariables[2];
  interface_chip_failure_case3.memory_failed = (Place*) LocalStateVariables[0];
  interface_chip_failure_case3.computer_failed = (Place*) LocalStateVariables[1];
  interface_chip_failure_case3.memory_chips = (Place*) LocalStateVariables[3];
  memory_chip_failure_case1.memory_chips = (Place*) LocalStateVariables[3];
  memory_chip_failure_case1.computer_failed = (Place*) LocalStateVariables[1];
  memory_chip_failure_case1.memory_failed = (Place*) LocalStateVariables[0];
  memory_chip_failure_case2.memory_chips = (Place*) LocalStateVariables[3];
  memory_chip_failure_case2.computer_failed = (Place*) LocalStateVariables[1];
  memory_chip_failure_case2.memory_failed = (Place*) LocalStateVariables[0];
  memory_chip_failure_case2.interface_chips = (Place*) LocalStateVariables[2];
  memory_chip_failure_case3.memory_chips = (Place*) LocalStateVariables[3];
  memory_chip_failure_case3.computer_failed = (Place*) LocalStateVariables[1];
  memory_chip_failure_case3.memory_failed = (Place*) LocalStateVariables[0];
  memory_chip_failure_case3.interface_chips = (Place*) LocalStateVariables[2];
  memory_chip_failure_case4.memory_chips = (Place*) LocalStateVariables[3];
  memory_chip_failure_case4.computer_failed = (Place*) LocalStateVariables[1];
  memory_chip_failure_case4.memory_failed = (Place*) LocalStateVariables[0];
  memory_chip_failure_case4.interface_chips = (Place*) LocalStateVariables[2];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================interface_chip_failureActivity_case1========================*/

memory_moduleSAN::interface_chip_failureActivity_case1::interface_chip_failureActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("interface_chip_failure_case1",0,Exponential, RaceEnabled, 4,3, true);
}

memory_moduleSAN::interface_chip_failureActivity_case1::~interface_chip_failureActivity_case1(){
  delete[] TheDistributionParameters;
}

void memory_moduleSAN::interface_chip_failureActivity_case1::LinkVariables(){
  interface_chips->Register(&interface_chips_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  memory_chips->Register(&memory_chips_Mobius_Mark);
}

bool memory_moduleSAN::interface_chip_failureActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((interface_chips->Mark() > 1) && (memory_failed->Mark() < 2) &&
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double memory_moduleSAN::interface_chip_failureActivity_case1::Rate(){
  return failure_rate * interface_chips->Mark();
  return 1.0;  // default rate if none is specified
}

double memory_moduleSAN::interface_chip_failureActivity_case1::Weight(){ 
  return mem_cov;
}

bool memory_moduleSAN::interface_chip_failureActivity_case1::ReactivationPredicate(){ 
  return 1;
}

bool memory_moduleSAN::interface_chip_failureActivity_case1::ReactivationFunction(){ 
  return 1;
}

double memory_moduleSAN::interface_chip_failureActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(failure_rate * interface_chips->Mark());
}

double* memory_moduleSAN::interface_chip_failureActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int memory_moduleSAN::interface_chip_failureActivity_case1::Rank(){
  return 1;
}

BaseActionClass* memory_moduleSAN::interface_chip_failureActivity_case1::Fire(){
  memory_chips->Mark() = 0;
  interface_chips->Mark() = 0;
memory_failed->Mark()++;
if (memory_failed->Mark() > 1)
	computer_failed->Mark()++;
  return this;
}

/*======================interface_chip_failureActivity_case2========================*/

memory_moduleSAN::interface_chip_failureActivity_case2::interface_chip_failureActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("interface_chip_failure_case2",0,Exponential, RaceEnabled, 4,3, true);
}

memory_moduleSAN::interface_chip_failureActivity_case2::~interface_chip_failureActivity_case2(){
  delete[] TheDistributionParameters;
}

void memory_moduleSAN::interface_chip_failureActivity_case2::LinkVariables(){
  interface_chips->Register(&interface_chips_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  memory_chips->Register(&memory_chips_Mobius_Mark);
}

bool memory_moduleSAN::interface_chip_failureActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((interface_chips->Mark() > 1) && (memory_failed->Mark() < 2) &&
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double memory_moduleSAN::interface_chip_failureActivity_case2::Rate(){
  return failure_rate * interface_chips->Mark();
  return 1.0;  // default rate if none is specified
}

double memory_moduleSAN::interface_chip_failureActivity_case2::Weight(){ 
  return ((1.0 - mem_cov) * (comp_cov));
}

bool memory_moduleSAN::interface_chip_failureActivity_case2::ReactivationPredicate(){ 
  return 1;
}

bool memory_moduleSAN::interface_chip_failureActivity_case2::ReactivationFunction(){ 
  return 1;
}

double memory_moduleSAN::interface_chip_failureActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(failure_rate * interface_chips->Mark());
}

double* memory_moduleSAN::interface_chip_failureActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int memory_moduleSAN::interface_chip_failureActivity_case2::Rank(){
  return 1;
}

BaseActionClass* memory_moduleSAN::interface_chip_failureActivity_case2::Fire(){
  memory_chips->Mark() = 0;
  interface_chips->Mark() = 0;
if ((memory_failed->Mark() == 1) && (computer_failed->Mark() <= num_comp - 2))
	computer_failed->Mark() = num_comp;
else
	computer_failed->Mark()++;
memory_failed->Mark() = 2;
  return this;
}

/*======================interface_chip_failureActivity_case3========================*/

memory_moduleSAN::interface_chip_failureActivity_case3::interface_chip_failureActivity_case3(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("interface_chip_failure_case3",0,Exponential, RaceEnabled, 4,3, true);
}

memory_moduleSAN::interface_chip_failureActivity_case3::~interface_chip_failureActivity_case3(){
  delete[] TheDistributionParameters;
}

void memory_moduleSAN::interface_chip_failureActivity_case3::LinkVariables(){
  interface_chips->Register(&interface_chips_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  memory_chips->Register(&memory_chips_Mobius_Mark);
}

bool memory_moduleSAN::interface_chip_failureActivity_case3::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((interface_chips->Mark() > 1) && (memory_failed->Mark() < 2) &&
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double memory_moduleSAN::interface_chip_failureActivity_case3::Rate(){
  return failure_rate * interface_chips->Mark();
  return 1.0;  // default rate if none is specified
}

double memory_moduleSAN::interface_chip_failureActivity_case3::Weight(){ 
  return (1.0 - mem_cov) * (1.0 - comp_cov);
}

bool memory_moduleSAN::interface_chip_failureActivity_case3::ReactivationPredicate(){ 
  return 1;
}

bool memory_moduleSAN::interface_chip_failureActivity_case3::ReactivationFunction(){ 
  return 1;
}

double memory_moduleSAN::interface_chip_failureActivity_case3::SampleDistribution(){
  return TheDistribution->Exponential(failure_rate * interface_chips->Mark());
}

double* memory_moduleSAN::interface_chip_failureActivity_case3::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int memory_moduleSAN::interface_chip_failureActivity_case3::Rank(){
  return 1;
}

BaseActionClass* memory_moduleSAN::interface_chip_failureActivity_case3::Fire(){
  memory_chips->Mark() = 0;
  interface_chips->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark() = num_comp;
  return this;
}

/*======================memory_chip_failureActivity_case1========================*/

memory_moduleSAN::memory_chip_failureActivity_case1::memory_chip_failureActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("memory_chip_failure_case1",1,Exponential, RaceEnabled, 1,3, true);
}

memory_moduleSAN::memory_chip_failureActivity_case1::~memory_chip_failureActivity_case1(){
  delete[] TheDistributionParameters;
}

void memory_moduleSAN::memory_chip_failureActivity_case1::LinkVariables(){
  memory_chips->Register(&memory_chips_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
}

bool memory_moduleSAN::memory_chip_failureActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((memory_chips->Mark() > 38) &&
(computer_failed->Mark() < num_comp) && 
(memory_failed->Mark() < 2)));
  return NewEnabled;
}

double memory_moduleSAN::memory_chip_failureActivity_case1::Rate(){
  return failure_rate * memory_chips->Mark();
  return 1.0;  // default rate if none is specified
}

double memory_moduleSAN::memory_chip_failureActivity_case1::Weight(){ 
  if (memory_chips->Mark() == 39)
	return(0.0);
else
	return(RAM_cov);
}

bool memory_moduleSAN::memory_chip_failureActivity_case1::ReactivationPredicate(){ 
  return 1;
}

bool memory_moduleSAN::memory_chip_failureActivity_case1::ReactivationFunction(){ 
  return 1;
}

double memory_moduleSAN::memory_chip_failureActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(failure_rate * memory_chips->Mark());
}

double* memory_moduleSAN::memory_chip_failureActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int memory_moduleSAN::memory_chip_failureActivity_case1::Rank(){
  return 1;
}

BaseActionClass* memory_moduleSAN::memory_chip_failureActivity_case1::Fire(){
  ;
  if (memory_chips->Mark() > 39)
	memory_chips->Mark()--;
  return this;
}

/*======================memory_chip_failureActivity_case2========================*/

memory_moduleSAN::memory_chip_failureActivity_case2::memory_chip_failureActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("memory_chip_failure_case2",1,Exponential, RaceEnabled, 4,3, true);
}

memory_moduleSAN::memory_chip_failureActivity_case2::~memory_chip_failureActivity_case2(){
  delete[] TheDistributionParameters;
}

void memory_moduleSAN::memory_chip_failureActivity_case2::LinkVariables(){
  memory_chips->Register(&memory_chips_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  interface_chips->Register(&interface_chips_Mobius_Mark);
}

bool memory_moduleSAN::memory_chip_failureActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((memory_chips->Mark() > 38) &&
(computer_failed->Mark() < num_comp) && 
(memory_failed->Mark() < 2)));
  return NewEnabled;
}

double memory_moduleSAN::memory_chip_failureActivity_case2::Rate(){
  return failure_rate * memory_chips->Mark();
  return 1.0;  // default rate if none is specified
}

double memory_moduleSAN::memory_chip_failureActivity_case2::Weight(){ 
  if (memory_chips->Mark() == 39)
	return(mem_cov);
else
	return((1.0 - RAM_cov) * mem_cov);
}

bool memory_moduleSAN::memory_chip_failureActivity_case2::ReactivationPredicate(){ 
  return 1;
}

bool memory_moduleSAN::memory_chip_failureActivity_case2::ReactivationFunction(){ 
  return 1;
}

double memory_moduleSAN::memory_chip_failureActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(failure_rate * memory_chips->Mark());
}

double* memory_moduleSAN::memory_chip_failureActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int memory_moduleSAN::memory_chip_failureActivity_case2::Rank(){
  return 1;
}

BaseActionClass* memory_moduleSAN::memory_chip_failureActivity_case2::Fire(){
  ;
  memory_chips->Mark() = 0;
interface_chips->Mark() = 0;
memory_failed->Mark()++;
if (memory_failed->Mark() > 1)
	computer_failed->Mark()++;
  return this;
}

/*======================memory_chip_failureActivity_case3========================*/

memory_moduleSAN::memory_chip_failureActivity_case3::memory_chip_failureActivity_case3(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("memory_chip_failure_case3",1,Exponential, RaceEnabled, 4,3, true);
}

memory_moduleSAN::memory_chip_failureActivity_case3::~memory_chip_failureActivity_case3(){
  delete[] TheDistributionParameters;
}

void memory_moduleSAN::memory_chip_failureActivity_case3::LinkVariables(){
  memory_chips->Register(&memory_chips_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  interface_chips->Register(&interface_chips_Mobius_Mark);
}

bool memory_moduleSAN::memory_chip_failureActivity_case3::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((memory_chips->Mark() > 38) &&
(computer_failed->Mark() < num_comp) && 
(memory_failed->Mark() < 2)));
  return NewEnabled;
}

double memory_moduleSAN::memory_chip_failureActivity_case3::Rate(){
  return failure_rate * memory_chips->Mark();
  return 1.0;  // default rate if none is specified
}

double memory_moduleSAN::memory_chip_failureActivity_case3::Weight(){ 
  if (memory_chips->Mark() == 39)
	return ((1.0 - mem_cov) * comp_cov);
else
	return ((1.0 - RAM_cov) * (1.0 - mem_cov) * (comp_cov));
}

bool memory_moduleSAN::memory_chip_failureActivity_case3::ReactivationPredicate(){ 
  return 1;
}

bool memory_moduleSAN::memory_chip_failureActivity_case3::ReactivationFunction(){ 
  return 1;
}

double memory_moduleSAN::memory_chip_failureActivity_case3::SampleDistribution(){
  return TheDistribution->Exponential(failure_rate * memory_chips->Mark());
}

double* memory_moduleSAN::memory_chip_failureActivity_case3::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int memory_moduleSAN::memory_chip_failureActivity_case3::Rank(){
  return 1;
}

BaseActionClass* memory_moduleSAN::memory_chip_failureActivity_case3::Fire(){
  ;
  memory_chips->Mark() = 0;
interface_chips->Mark() = 0;
if ((memory_failed->Mark() == 1) && (computer_failed->Mark() <= num_comp - 2))
	computer_failed->Mark() = num_comp;
else
	computer_failed->Mark()++;
memory_failed->Mark() = 2;
  return this;
}

/*======================memory_chip_failureActivity_case4========================*/

memory_moduleSAN::memory_chip_failureActivity_case4::memory_chip_failureActivity_case4(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("memory_chip_failure_case4",1,Exponential, RaceEnabled, 4,3, true);
}

memory_moduleSAN::memory_chip_failureActivity_case4::~memory_chip_failureActivity_case4(){
  delete[] TheDistributionParameters;
}

void memory_moduleSAN::memory_chip_failureActivity_case4::LinkVariables(){
  memory_chips->Register(&memory_chips_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  interface_chips->Register(&interface_chips_Mobius_Mark);
}

bool memory_moduleSAN::memory_chip_failureActivity_case4::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((memory_chips->Mark() > 38) &&
(computer_failed->Mark() < num_comp) && 
(memory_failed->Mark() < 2)));
  return NewEnabled;
}

double memory_moduleSAN::memory_chip_failureActivity_case4::Rate(){
  return failure_rate * memory_chips->Mark();
  return 1.0;  // default rate if none is specified
}

double memory_moduleSAN::memory_chip_failureActivity_case4::Weight(){ 
  if (memory_chips->Mark() == 39)
	return((1.0 - mem_cov) * (1.0 - comp_cov));
else
	return((1.0 - RAM_cov) * (1.0 - mem_cov) * (1.0 - comp_cov));
}

bool memory_moduleSAN::memory_chip_failureActivity_case4::ReactivationPredicate(){ 
  return 1;
}

bool memory_moduleSAN::memory_chip_failureActivity_case4::ReactivationFunction(){ 
  return 1;
}

double memory_moduleSAN::memory_chip_failureActivity_case4::SampleDistribution(){
  return TheDistribution->Exponential(failure_rate * memory_chips->Mark());
}

double* memory_moduleSAN::memory_chip_failureActivity_case4::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int memory_moduleSAN::memory_chip_failureActivity_case4::Rank(){
  return 1;
}

BaseActionClass* memory_moduleSAN::memory_chip_failureActivity_case4::Fire(){
  ;
  memory_chips->Mark() = 0;
interface_chips->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark() = num_comp;
  return this;
}

