#ifndef memory_moduleSAN_H_
#define memory_moduleSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double failure_rate;
extern double RAM_cov;
extern double mem_cov;
extern double comp_cov;
extern short num_comp;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               memory_moduleSAN Submodel Definition                   
*********************************************************************/

class memory_moduleSAN:public SANModel{
public:

class interface_chip_failureActivity_case1:public Activity {
public:

  Place* interface_chips;
  short* interface_chips_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* memory_chips;
  short* memory_chips_Mobius_Mark;

  double* TheDistributionParameters;
  interface_chip_failureActivity_case1();
  ~interface_chip_failureActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // interface_chip_failureActivity_case1Activity

class interface_chip_failureActivity_case2:public Activity {
public:

  Place* interface_chips;
  short* interface_chips_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* memory_chips;
  short* memory_chips_Mobius_Mark;

  double* TheDistributionParameters;
  interface_chip_failureActivity_case2();
  ~interface_chip_failureActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // interface_chip_failureActivity_case2Activity

class interface_chip_failureActivity_case3:public Activity {
public:

  Place* interface_chips;
  short* interface_chips_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* memory_chips;
  short* memory_chips_Mobius_Mark;

  double* TheDistributionParameters;
  interface_chip_failureActivity_case3();
  ~interface_chip_failureActivity_case3();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // interface_chip_failureActivity_case3Activity

class memory_chip_failureActivity_case1:public Activity {
public:

  Place* memory_chips;
  short* memory_chips_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;

  double* TheDistributionParameters;
  memory_chip_failureActivity_case1();
  ~memory_chip_failureActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // memory_chip_failureActivity_case1Activity

class memory_chip_failureActivity_case2:public Activity {
public:

  Place* memory_chips;
  short* memory_chips_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* interface_chips;
  short* interface_chips_Mobius_Mark;

  double* TheDistributionParameters;
  memory_chip_failureActivity_case2();
  ~memory_chip_failureActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // memory_chip_failureActivity_case2Activity

class memory_chip_failureActivity_case3:public Activity {
public:

  Place* memory_chips;
  short* memory_chips_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* interface_chips;
  short* interface_chips_Mobius_Mark;

  double* TheDistributionParameters;
  memory_chip_failureActivity_case3();
  ~memory_chip_failureActivity_case3();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // memory_chip_failureActivity_case3Activity

class memory_chip_failureActivity_case4:public Activity {
public:

  Place* memory_chips;
  short* memory_chips_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* interface_chips;
  short* interface_chips_Mobius_Mark;

  double* TheDistributionParameters;
  memory_chip_failureActivity_case4();
  ~memory_chip_failureActivity_case4();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // memory_chip_failureActivity_case4Activity

  //List of user-specified place names
  Place* memory_failed;
  Place* computer_failed;
  Place* interface_chips;
  Place* memory_chips;

  // Create instances of all actvities
  interface_chip_failureActivity_case1 interface_chip_failure_case1;
  interface_chip_failureActivity_case2 interface_chip_failure_case2;
  interface_chip_failureActivity_case3 interface_chip_failure_case3;
  memory_chip_failureActivity_case1 memory_chip_failure_case1;
  memory_chip_failureActivity_case2 memory_chip_failure_case2;
  memory_chip_failureActivity_case3 memory_chip_failure_case3;
  memory_chip_failureActivity_case4 memory_chip_failure_case4;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;
  PostselectGroup interface_chip_failureGroup;  PostselectGroup memory_chip_failureGroup;
  memory_moduleSAN();
  ~memory_moduleSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end memory_moduleSAN

#endif // memory_moduleSAN_H_
