#include "Composed/multi_proc/multi_procRJ.h"
char * multi_procRJ__SharedNames[] = {"computer_failed"};

multi_procRJ::multi_procRJ():Rep("Multi-Processor", num_comp, 1, multi_procRJ__SharedNames)
{
  InstanceArray = new multi_procRJ__Computer * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new multi_procRJ__Computer();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    computer_failed = new Place("computer_failed");
    addSharedPtr(computer_failed, "computer_failed");
    computer_failed->ShareWith(InstanceArray[0]->computer_failed);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->computer_failed, computer_failed);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->computer_failed->ShareWith(InstanceArray[counter]->computer_failed);
    }
  }
  Setup("Computer");
}

multi_procRJ::~multi_procRJ() {
  if (NumModels == 0) return;
  delete computer_failed;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

