#include "Composed/multi_proc/multi_procRJ__Computer.h"
char * multi_procRJ__Computer__SharedNames[] = {"computer_failed", "cpus", "errorhandler", "ioports", "memory_failed"};

multi_procRJ__Computer::multi_procRJ__Computer():Join("Computer", 4, 5,multi_procRJ__Computer__SharedNames) {
  Memory = new multi_procRJ__Memory();
  ModelArray[0] = (BaseModelClass*) Memory;
  ModelArray[0]->DefineName("Memory");
  io_port_module = new io_port_moduleSAN();
  ModelArray[1] = (BaseModelClass*) io_port_module;
  ModelArray[1]->DefineName("io_port_module");
  errorhandlers = new errorhandlersSAN();
  ModelArray[2] = (BaseModelClass*) errorhandlers;
  ModelArray[2]->DefineName("errorhandlers");
  cpu_module = new cpu_moduleSAN();
  ModelArray[3] = (BaseModelClass*) cpu_module;
  ModelArray[3]->DefineName("cpu_module");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    computer_failed = new Place("computer_failed");
    addSharedPtr(computer_failed, "computer_failed" );
    if (Memory->NumStateVariables > 0) {
      computer_failed->ShareWith(Memory->computer_failed);
      addSharingInfo(Memory->computer_failed, computer_failed, Memory);
    }
    if (io_port_module->NumStateVariables > 0) {
      computer_failed->ShareWith(io_port_module->computer_failed);
      addSharingInfo(io_port_module->computer_failed, computer_failed, io_port_module);
    }
    if (errorhandlers->NumStateVariables > 0) {
      computer_failed->ShareWith(errorhandlers->computer_failed);
      addSharingInfo(errorhandlers->computer_failed, computer_failed, errorhandlers);
    }
    if (cpu_module->NumStateVariables > 0) {
      computer_failed->ShareWith(cpu_module->computer_failed);
      addSharingInfo(cpu_module->computer_failed, computer_failed, cpu_module);
    }

    //Shared variable 1
    cpus = new Place("cpus");
    addSharedPtr(cpus, "cpus" );
    if (cpu_module->NumStateVariables > 0) {
      cpus->ShareWith(cpu_module->cpus);
      addSharingInfo(cpu_module->cpus, cpus, cpu_module);
    }
    if (errorhandlers->NumStateVariables > 0) {
      cpus->ShareWith(errorhandlers->cpus);
      addSharingInfo(errorhandlers->cpus, cpus, errorhandlers);
    }
    if (io_port_module->NumStateVariables > 0) {
      cpus->ShareWith(io_port_module->cpus);
      addSharingInfo(io_port_module->cpus, cpus, io_port_module);
    }

    //Shared variable 2
    errorhandler = new Place("errorhandler");
    addSharedPtr(errorhandler, "errorhandler" );
    if (cpu_module->NumStateVariables > 0) {
      errorhandler->ShareWith(cpu_module->errorhandlers);
      addSharingInfo(cpu_module->errorhandlers, errorhandler, cpu_module);
    }
    if (errorhandlers->NumStateVariables > 0) {
      errorhandler->ShareWith(errorhandlers->errorhandlers);
      addSharingInfo(errorhandlers->errorhandlers, errorhandler, errorhandlers);
    }
    if (io_port_module->NumStateVariables > 0) {
      errorhandler->ShareWith(io_port_module->errorhandlers);
      addSharingInfo(io_port_module->errorhandlers, errorhandler, io_port_module);
    }

    //Shared variable 3
    ioports = new Place("ioports");
    addSharedPtr(ioports, "ioports" );
    if (cpu_module->NumStateVariables > 0) {
      ioports->ShareWith(cpu_module->ioports);
      addSharingInfo(cpu_module->ioports, ioports, cpu_module);
    }
    if (errorhandlers->NumStateVariables > 0) {
      ioports->ShareWith(errorhandlers->ioports);
      addSharingInfo(errorhandlers->ioports, ioports, errorhandlers);
    }
    if (io_port_module->NumStateVariables > 0) {
      ioports->ShareWith(io_port_module->ioports);
      addSharingInfo(io_port_module->ioports, ioports, io_port_module);
    }

    //Shared variable 4
    memory_failed = new Place("memory_failed");
    addSharedPtr(memory_failed, "memory_failed" );
    if (Memory->NumStateVariables > 0) {
      memory_failed->ShareWith(Memory->memory_failed);
      addSharingInfo(Memory->memory_failed, memory_failed, Memory);
    }
    if (io_port_module->NumStateVariables > 0) {
      memory_failed->ShareWith(io_port_module->memory_failed);
      addSharingInfo(io_port_module->memory_failed, memory_failed, io_port_module);
    }
    if (errorhandlers->NumStateVariables > 0) {
      memory_failed->ShareWith(errorhandlers->memory_failed);
      addSharingInfo(errorhandlers->memory_failed, memory_failed, errorhandlers);
    }
    if (cpu_module->NumStateVariables > 0) {
      memory_failed->ShareWith(cpu_module->memory_failed);
      addSharingInfo(cpu_module->memory_failed, memory_failed, cpu_module);
    }

  }

  Setup();
}

multi_procRJ__Computer::~multi_procRJ__Computer() {
  if (!AllChildrenEmpty()) {
    delete computer_failed;
    delete cpus;
    delete errorhandler;
    delete ioports;
    delete memory_failed;
  }
  delete Memory;
  delete io_port_module;
  delete errorhandlers;
  delete cpu_module;
}
