#ifndef multi_procRJ__Computer_H_
#define multi_procRJ__Computer_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/multi_proc/multi_procRJ__Memory.h"
#include "Atomic/io_port_module/io_port_moduleSAN.h"
#include "Atomic/errorhandlers/errorhandlersSAN.h"
#include "Atomic/cpu_module/cpu_moduleSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
extern short num_mem_mod;

class multi_procRJ__Computer: public Join {
 public:
  multi_procRJ__Memory * Memory;
  io_port_moduleSAN * io_port_module;
  errorhandlersSAN * errorhandlers;
  cpu_moduleSAN * cpu_module;
  Place * computer_failed;
  Place * cpus;
  Place * errorhandler;
  Place * ioports;
  Place * memory_failed;

  multi_procRJ__Computer();
  ~multi_procRJ__Computer();
};

#endif
