#include "MultiProc_PVPVNodes.h"

MultiProc_PVPV0Worker::MultiProc_PVPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&cpu_module);
}

MultiProc_PVPV0Worker::~MultiProc_PVPV0Worker() {
  delete [] TheModelPtr;
}

double MultiProc_PVPV0Worker::Reward_Function(void) {

if (cpu_module->computer_failed->Mark() == num_comp)
{
	return 1.0/num_comp;
}

return (0);



}

MultiProc_PVPV0::MultiProc_PVPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Themulti_procRJ);
  double startpts[1]={5.0};
  double stoppts[1]={5.0};
  Initialize("unreliability",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("computer_failed","cpu_module");
}

MultiProc_PVPV0::~MultiProc_PVPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MultiProc_PVPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MultiProc_PVPV0Worker;
}
