
#ifndef vary_num_compRangeSTUDY_H_
#define vary_num_compRangeSTUDY_H_

#include "Reward/MultiProc_PV/MultiProc_PVPVNodes.h"
#include "Reward/MultiProc_PV/MultiProc_PVPVModel.h"
#include "Cpp/Study/BaseStudyClass.hpp"

extern double CPU_cov;
extern double IO_cov;
extern double RAM_cov;
extern double comp_cov;
extern double failure_rate;
extern double mem_cov;
extern short num_comp;
extern short num_mem_mod;

class vary_num_compRangeStudy : public BaseStudyClass {
public:

vary_num_compRangeStudy();
~vary_num_compRangeStudy();

private:

double *CPU_covValues;
double *IO_covValues;
double *RAM_covValues;
double *comp_covValues;
double *failure_rateValues;
double *mem_covValues;
short *num_compValues;
short *num_mem_modValues;

void SetValues_CPU_cov();
void SetValues_IO_cov();
void SetValues_RAM_cov();
void SetValues_comp_cov();
void SetValues_failure_rate();
void SetValues_mem_cov();
void SetValues_num_comp();
void SetValues_num_mem_mod();

void PrintGlobalValues(int);
void *GetGVValue(char *TheGVName);
void OverrideGVValue(char *TheGVName, void *TheGVValue);
void SetGVs(int expnum);
PVModel *GetPVModel(bool expandTimeArrays);
};

#endif

