

// This C++ file was created by SanEditor

#include "Atomic/cpu_module/cpu_moduleSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         cpu_moduleSAN Constructor             
******************************************************************/


cpu_moduleSAN::cpu_moduleSAN(){


  cpu_failureGroup.initialize(3, "cpu_failureGroup");
  cpu_failureGroup.appendGroup((BaseGroupClass*) &cpu_failure_case1);
  cpu_failureGroup.appendGroup((BaseGroupClass*) &cpu_failure_case2);
  cpu_failureGroup.appendGroup((BaseGroupClass*) &cpu_failure_case3);

  Activity* InitialActionList[3]={
    &cpu_failure_case1, //0
    &cpu_failure_case2, //1
    &cpu_failure_case3  // 2
  };

  BaseGroupClass* InitialGroupList[1]={
    (BaseGroupClass*) &(cpu_failureGroup)
  };

  ioports = new Place("ioports" ,2);
  cpus = new Place("cpus" ,3);
  errorhandlers = new Place("errorhandlers" ,2);
  memory_failed = new Place("memory_failed" ,0);
  computer_failed = new Place("computer_failed" ,0);
  BaseStateVariableClass* InitialPlaces[5]={
    ioports,  // 0
    cpus,  // 1
    errorhandlers,  // 2
    memory_failed,  // 3
    computer_failed   // 4
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("cpu_module", 5, InitialPlaces, 
                        0, InitialROPlaces, 
                        3, InitialActionList, 1, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[11][2]={ 
    {1,0}, {1,1}, {0,1}, {2,1}, {3,1}, {4,1}, {1,2}, {0,2}, {2,2}, 
    {3,2}, {4,2}
  };
  for(int n=0;n<11;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[9][2]={ 
    {1,0}, {3,0}, {4,0}, {1,1}, {3,1}, {4,1}, {1,2}, {3,2}, {4,2}
  };
  for(int n=0;n<9;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<3;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void cpu_moduleSAN::CustomInitialization() {

}
cpu_moduleSAN::~cpu_moduleSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void cpu_moduleSAN::assignPlacesToActivitiesInst(){
}
void cpu_moduleSAN::assignPlacesToActivitiesTimed(){
  cpu_failure_case1.cpus = (Place*) LocalStateVariables[1];
  cpu_failure_case1.memory_failed = (Place*) LocalStateVariables[3];
  cpu_failure_case1.computer_failed = (Place*) LocalStateVariables[4];
  cpu_failure_case2.cpus = (Place*) LocalStateVariables[1];
  cpu_failure_case2.memory_failed = (Place*) LocalStateVariables[3];
  cpu_failure_case2.computer_failed = (Place*) LocalStateVariables[4];
  cpu_failure_case2.ioports = (Place*) LocalStateVariables[0];
  cpu_failure_case2.errorhandlers = (Place*) LocalStateVariables[2];
  cpu_failure_case3.cpus = (Place*) LocalStateVariables[1];
  cpu_failure_case3.memory_failed = (Place*) LocalStateVariables[3];
  cpu_failure_case3.computer_failed = (Place*) LocalStateVariables[4];
  cpu_failure_case3.ioports = (Place*) LocalStateVariables[0];
  cpu_failure_case3.errorhandlers = (Place*) LocalStateVariables[2];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================cpu_failureActivity_case1========================*/

cpu_moduleSAN::cpu_failureActivity_case1::cpu_failureActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("cpu_failure_case1",0,Exponential, RaceEnabled, 1,3, true);
}

cpu_moduleSAN::cpu_failureActivity_case1::~cpu_failureActivity_case1(){
  delete[] TheDistributionParameters;
}

void cpu_moduleSAN::cpu_failureActivity_case1::LinkVariables(){
  cpus->Register(&cpus_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
}

bool cpu_moduleSAN::cpu_failureActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((cpus->Mark() > 1) && (memory_failed->Mark() < 2) &&
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double cpu_moduleSAN::cpu_failureActivity_case1::Rate(){
  return 6.0  * failure_rate  * cpus->Mark();
  return 1.0;  // default rate if none is specified
}

double cpu_moduleSAN::cpu_failureActivity_case1::Weight(){ 
  if (cpus->Mark() == 3)
	return(CPU_cov);
else
	return(0.0);
}

bool cpu_moduleSAN::cpu_failureActivity_case1::ReactivationPredicate(){ 
  return 1;
}

bool cpu_moduleSAN::cpu_failureActivity_case1::ReactivationFunction(){ 
  return 1;
}

double cpu_moduleSAN::cpu_failureActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(6.0  * failure_rate  * cpus->Mark());
}

double* cpu_moduleSAN::cpu_failureActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int cpu_moduleSAN::cpu_failureActivity_case1::Rank(){
  return 1;
}

BaseActionClass* cpu_moduleSAN::cpu_failureActivity_case1::Fire(){
  ;
  if (cpus->Mark() == 3)
	cpus->Mark()--;
  return this;
}

/*======================cpu_failureActivity_case2========================*/

cpu_moduleSAN::cpu_failureActivity_case2::cpu_failureActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("cpu_failure_case2",0,Exponential, RaceEnabled, 5,3, true);
}

cpu_moduleSAN::cpu_failureActivity_case2::~cpu_failureActivity_case2(){
  delete[] TheDistributionParameters;
}

void cpu_moduleSAN::cpu_failureActivity_case2::LinkVariables(){
  cpus->Register(&cpus_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  ioports->Register(&ioports_Mobius_Mark);
  errorhandlers->Register(&errorhandlers_Mobius_Mark);
}

bool cpu_moduleSAN::cpu_failureActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((cpus->Mark() > 1) && (memory_failed->Mark() < 2) &&
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double cpu_moduleSAN::cpu_failureActivity_case2::Rate(){
  return 6.0  * failure_rate  * cpus->Mark();
  return 1.0;  // default rate if none is specified
}

double cpu_moduleSAN::cpu_failureActivity_case2::Weight(){ 
  if (cpus->Mark() ==3)
	return((1.0 - CPU_cov) * comp_cov);
else
	return(comp_cov);
}

bool cpu_moduleSAN::cpu_failureActivity_case2::ReactivationPredicate(){ 
  return 1;
}

bool cpu_moduleSAN::cpu_failureActivity_case2::ReactivationFunction(){ 
  return 1;
}

double cpu_moduleSAN::cpu_failureActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(6.0  * failure_rate  * cpus->Mark());
}

double* cpu_moduleSAN::cpu_failureActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int cpu_moduleSAN::cpu_failureActivity_case2::Rank(){
  return 1;
}

BaseActionClass* cpu_moduleSAN::cpu_failureActivity_case2::Fire(){
  ;
  cpus->Mark() = 0;
ioports->Mark() = 0;
errorhandlers->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark()++;
  return this;
}

/*======================cpu_failureActivity_case3========================*/

cpu_moduleSAN::cpu_failureActivity_case3::cpu_failureActivity_case3(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("cpu_failure_case3",0,Exponential, RaceEnabled, 5,3, true);
}

cpu_moduleSAN::cpu_failureActivity_case3::~cpu_failureActivity_case3(){
  delete[] TheDistributionParameters;
}

void cpu_moduleSAN::cpu_failureActivity_case3::LinkVariables(){
  cpus->Register(&cpus_Mobius_Mark);
  memory_failed->Register(&memory_failed_Mobius_Mark);
  computer_failed->Register(&computer_failed_Mobius_Mark);
  ioports->Register(&ioports_Mobius_Mark);
  errorhandlers->Register(&errorhandlers_Mobius_Mark);
}

bool cpu_moduleSAN::cpu_failureActivity_case3::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((cpus->Mark() > 1) && (memory_failed->Mark() < 2) &&
(computer_failed->Mark() < num_comp)));
  return NewEnabled;
}

double cpu_moduleSAN::cpu_failureActivity_case3::Rate(){
  return 6.0  * failure_rate  * cpus->Mark();
  return 1.0;  // default rate if none is specified
}

double cpu_moduleSAN::cpu_failureActivity_case3::Weight(){ 
  if (cpus->Mark() == 3)
	return((1.0 - CPU_cov) * (1.0 - comp_cov));
else
	return(1.0 - comp_cov);
}

bool cpu_moduleSAN::cpu_failureActivity_case3::ReactivationPredicate(){ 
  return 1;
}

bool cpu_moduleSAN::cpu_failureActivity_case3::ReactivationFunction(){ 
  return 1;
}

double cpu_moduleSAN::cpu_failureActivity_case3::SampleDistribution(){
  return TheDistribution->Exponential(6.0  * failure_rate  * cpus->Mark());
}

double* cpu_moduleSAN::cpu_failureActivity_case3::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int cpu_moduleSAN::cpu_failureActivity_case3::Rank(){
  return 1;
}

BaseActionClass* cpu_moduleSAN::cpu_failureActivity_case3::Fire(){
  ;
  cpus->Mark() = 0;
ioports->Mark() = 0;
errorhandlers->Mark() = 0;
memory_failed->Mark() = 2;
computer_failed->Mark() = num_comp;
  return this;
}

