#ifndef cpu_moduleSAN_H_
#define cpu_moduleSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double failure_rate;
extern double CPU_cov;
extern double comp_cov;
extern short num_comp;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               cpu_moduleSAN Submodel Definition                   
*********************************************************************/

class cpu_moduleSAN:public SANModel{
public:

class cpu_failureActivity_case1:public Activity {
public:

  Place* cpus;
  short* cpus_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;

  double* TheDistributionParameters;
  cpu_failureActivity_case1();
  ~cpu_failureActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // cpu_failureActivity_case1Activity

class cpu_failureActivity_case2:public Activity {
public:

  Place* cpus;
  short* cpus_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* ioports;
  short* ioports_Mobius_Mark;
  Place* errorhandlers;
  short* errorhandlers_Mobius_Mark;

  double* TheDistributionParameters;
  cpu_failureActivity_case2();
  ~cpu_failureActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // cpu_failureActivity_case2Activity

class cpu_failureActivity_case3:public Activity {
public:

  Place* cpus;
  short* cpus_Mobius_Mark;
  Place* memory_failed;
  short* memory_failed_Mobius_Mark;
  Place* computer_failed;
  short* computer_failed_Mobius_Mark;
  Place* ioports;
  short* ioports_Mobius_Mark;
  Place* errorhandlers;
  short* errorhandlers_Mobius_Mark;

  double* TheDistributionParameters;
  cpu_failureActivity_case3();
  ~cpu_failureActivity_case3();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // cpu_failureActivity_case3Activity

  //List of user-specified place names
  Place* ioports;
  Place* cpus;
  Place* errorhandlers;
  Place* memory_failed;
  Place* computer_failed;

  // Create instances of all actvities
  cpu_failureActivity_case1 cpu_failure_case1;
  cpu_failureActivity_case2 cpu_failure_case2;
  cpu_failureActivity_case3 cpu_failure_case3;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;
  PostselectGroup cpu_failureGroup;
  cpu_moduleSAN();
  ~cpu_moduleSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end cpu_moduleSAN

#endif // cpu_moduleSAN_H_
