#include "Composed/multi_proc/multi_procRJ__JOIN1.h"
char * multi_procRJ__JOIN1__SharedNames[] = {"computer_failed", "cpus", "errorhandlers", "ioports", "memory_failed"};

multi_procRJ__JOIN1::multi_procRJ__JOIN1():Join("JOIN1", 4, 5,multi_procRJ__JOIN1__SharedNames) {
  REP1 = new multi_procRJ__REP1();
  ModelArray[0] = (BaseModelClass*) REP1;
  ModelArray[0]->DefineName("REP1");
  cpu_module = new cpu_moduleSAN();
  ModelArray[1] = (BaseModelClass*) cpu_module;
  ModelArray[1]->DefineName("cpu_module");
  errorhandler = new errorhandlersSAN();
  ModelArray[2] = (BaseModelClass*) errorhandler;
  ModelArray[2]->DefineName("errorhandler");
  io_port_module = new io_port_moduleSAN();
  ModelArray[3] = (BaseModelClass*) io_port_module;
  ModelArray[3]->DefineName("io_port_module");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    computer_failed = new Place("computer_failed");
    addSharedPtr(computer_failed, "computer_failed" );
    if (REP1->NumStateVariables > 0) {
      computer_failed->ShareWith(REP1->computer_failed);
      addSharingInfo(REP1->computer_failed, computer_failed, REP1);
    }
    if (cpu_module->NumStateVariables > 0) {
      computer_failed->ShareWith(cpu_module->computer_failed);
      addSharingInfo(cpu_module->computer_failed, computer_failed, cpu_module);
    }
    if (errorhandler->NumStateVariables > 0) {
      computer_failed->ShareWith(errorhandler->computer_failed);
      addSharingInfo(errorhandler->computer_failed, computer_failed, errorhandler);
    }
    if (io_port_module->NumStateVariables > 0) {
      computer_failed->ShareWith(io_port_module->computer_failed);
      addSharingInfo(io_port_module->computer_failed, computer_failed, io_port_module);
    }

    //Shared variable 1
    cpus = new Place("cpus");
    addSharedPtr(cpus, "cpus" );
    if (cpu_module->NumStateVariables > 0) {
      cpus->ShareWith(cpu_module->cpus);
      addSharingInfo(cpu_module->cpus, cpus, cpu_module);
    }
    if (errorhandler->NumStateVariables > 0) {
      cpus->ShareWith(errorhandler->cpus);
      addSharingInfo(errorhandler->cpus, cpus, errorhandler);
    }
    if (io_port_module->NumStateVariables > 0) {
      cpus->ShareWith(io_port_module->cpus);
      addSharingInfo(io_port_module->cpus, cpus, io_port_module);
    }

    //Shared variable 2
    errorhandlers = new Place("errorhandlers");
    addSharedPtr(errorhandlers, "errorhandlers" );
    if (cpu_module->NumStateVariables > 0) {
      errorhandlers->ShareWith(cpu_module->errorhandlers);
      addSharingInfo(cpu_module->errorhandlers, errorhandlers, cpu_module);
    }
    if (errorhandler->NumStateVariables > 0) {
      errorhandlers->ShareWith(errorhandler->errorhandlers);
      addSharingInfo(errorhandler->errorhandlers, errorhandlers, errorhandler);
    }
    if (io_port_module->NumStateVariables > 0) {
      errorhandlers->ShareWith(io_port_module->errorhandlers);
      addSharingInfo(io_port_module->errorhandlers, errorhandlers, io_port_module);
    }

    //Shared variable 3
    ioports = new Place("ioports");
    addSharedPtr(ioports, "ioports" );
    if (cpu_module->NumStateVariables > 0) {
      ioports->ShareWith(cpu_module->ioports);
      addSharingInfo(cpu_module->ioports, ioports, cpu_module);
    }
    if (errorhandler->NumStateVariables > 0) {
      ioports->ShareWith(errorhandler->ioports);
      addSharingInfo(errorhandler->ioports, ioports, errorhandler);
    }
    if (io_port_module->NumStateVariables > 0) {
      ioports->ShareWith(io_port_module->ioports);
      addSharingInfo(io_port_module->ioports, ioports, io_port_module);
    }

    //Shared variable 4
    memory_failed = new Place("memory_failed");
    addSharedPtr(memory_failed, "memory_failed" );
    if (REP1->NumStateVariables > 0) {
      memory_failed->ShareWith(REP1->memory_failed);
      addSharingInfo(REP1->memory_failed, memory_failed, REP1);
    }
    if (cpu_module->NumStateVariables > 0) {
      memory_failed->ShareWith(cpu_module->memory_failed);
      addSharingInfo(cpu_module->memory_failed, memory_failed, cpu_module);
    }
    if (errorhandler->NumStateVariables > 0) {
      memory_failed->ShareWith(errorhandler->memory_failed);
      addSharingInfo(errorhandler->memory_failed, memory_failed, errorhandler);
    }
    if (io_port_module->NumStateVariables > 0) {
      memory_failed->ShareWith(io_port_module->memory_failed);
      addSharingInfo(io_port_module->memory_failed, memory_failed, io_port_module);
    }

  }

  Setup();
}

multi_procRJ__JOIN1::~multi_procRJ__JOIN1() {
  if (!AllChildrenEmpty()) {
    delete computer_failed;
    delete cpus;
    delete errorhandlers;
    delete ioports;
    delete memory_failed;
  }
  delete REP1;
  delete cpu_module;
  delete errorhandler;
  delete io_port_module;
}
