#include "Composed/multi_proc/multi_procRJ__REP1.h"
char * multi_procRJ__REP1__SharedNames[] = {"computer_failed", "memory_failed"};

multi_procRJ__REP1::multi_procRJ__REP1():Rep("REP1", num_mem_mod, 2, multi_procRJ__REP1__SharedNames)
{
  InstanceArray = new memory_moduleSAN * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new memory_moduleSAN();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    computer_failed = new Place("computer_failed");
    addSharedPtr(computer_failed, "computer_failed");
    computer_failed->ShareWith(InstanceArray[0]->computer_failed);

    memory_failed = new Place("memory_failed");
    addSharedPtr(memory_failed, "memory_failed");
    memory_failed->ShareWith(InstanceArray[0]->memory_failed);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->computer_failed, computer_failed);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->memory_failed, memory_failed);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->computer_failed->ShareWith(InstanceArray[counter]->computer_failed);
      InstanceArray[0]->memory_failed->ShareWith(InstanceArray[counter]->memory_failed);
    }
  }
  Setup("memory_module");
}

multi_procRJ__REP1::~multi_procRJ__REP1() {
  if (NumModels == 0) return;
  delete computer_failed;
  delete memory_failed;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

