#include "multi_proc_PVPVNodes.h"

multi_proc_PVPV0Impulse0::multi_proc_PVPV0Impulse0()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&cpu_module);
  ImpulseWorkerListLength = 0;
}

multi_proc_PVPV0Impulse0::~multi_proc_PVPV0Impulse0() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double multi_proc_PVPV0Impulse0::Impulse_Function(double FiringTime)
{
return 1;

return(0);
}

ImpulseNodeClass** multi_proc_PVPV0Impulse0::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new multi_proc_PVPV0Impulse0;
  }

  return ImpulseWorkerList;
}

multi_proc_PVPV0Impulse1::multi_proc_PVPV0Impulse1()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&cpu_module);
  ImpulseWorkerListLength = 0;
}

multi_proc_PVPV0Impulse1::~multi_proc_PVPV0Impulse1() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double multi_proc_PVPV0Impulse1::Impulse_Function(double FiringTime)
{
return 1;

return(0);
}

ImpulseNodeClass** multi_proc_PVPV0Impulse1::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new multi_proc_PVPV0Impulse1;
  }

  return ImpulseWorkerList;
}

multi_proc_PVPV0Impulse2::multi_proc_PVPV0Impulse2()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&cpu_module);
  ImpulseWorkerListLength = 0;
}

multi_proc_PVPV0Impulse2::~multi_proc_PVPV0Impulse2() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double multi_proc_PVPV0Impulse2::Impulse_Function(double FiringTime)
{
return 1;

return(0);
}

ImpulseNodeClass** multi_proc_PVPV0Impulse2::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new multi_proc_PVPV0Impulse2;
  }

  return ImpulseWorkerList;
}

multi_proc_PVPV0Worker::multi_proc_PVPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&cpu_module);
}

multi_proc_PVPV0Worker::~multi_proc_PVPV0Worker() {
  delete [] TheModelPtr;
}

double multi_proc_PVPV0Worker::Reward_Function(void) {

double reward = 0;
if (cpu_module->computer_failed->Mark() == num_comp)
     {
        reward += 1.0 / num_comp;
     }
return (reward);

return (0);



}

multi_proc_PVPV0::multi_proc_PVPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Themulti_procRJ);
  double startpts[1]={20.0};
  double stoppts[1]={20.0};
  Initialize("Unreliability",(RewardType)0,1, startpts, stoppts, timeindex, 3,1, 1);
  AddVariableDependency("computer_failed","cpu_module");
  AddImpulse("cpu_failure_case1","cpu_module",&Impulse0);
  AddImpulse("cpu_failure_case2","cpu_module",&Impulse1);
  AddImpulse("cpu_failure_case3","cpu_module",&Impulse2);
}

multi_proc_PVPV0::~multi_proc_PVPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void multi_proc_PVPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new multi_proc_PVPV0Worker;
}
