#ifndef _MULTI_PROC_PV_PVS_
#define _MULTI_PROC_PV_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/multi_proc/multi_procRJ__REP1.h"
#include "Composed/multi_proc/multi_procRJ.h"
#include "Composed/multi_proc/multi_procRJ__JOIN1.h"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"
#include "Cpp/Performance_Variables/InstantOfTimeImpulse.hpp"



class multi_proc_PVPV0Impulse0:public InstantOfTimeImpulse
{
 public:
  cpu_moduleSAN *cpu_module;

  multi_proc_PVPV0Impulse0();
  ~multi_proc_PVPV0Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};


class multi_proc_PVPV0Impulse1:public InstantOfTimeImpulse
{
 public:
  cpu_moduleSAN *cpu_module;

  multi_proc_PVPV0Impulse1();
  ~multi_proc_PVPV0Impulse1();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};


class multi_proc_PVPV0Impulse2:public InstantOfTimeImpulse
{
 public:
  cpu_moduleSAN *cpu_module;

  multi_proc_PVPV0Impulse2();
  ~multi_proc_PVPV0Impulse2();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};

class multi_proc_PVPV0Worker:public InstantOfTime
{
 public:
  cpu_moduleSAN *cpu_module;
  
  multi_proc_PVPV0Worker();
  ~multi_proc_PVPV0Worker();
  double Reward_Function();
};

class multi_proc_PVPV0:public PerformanceVariableNode
{
 public:
  multi_procRJ *Themulti_procRJ;

  multi_proc_PVPV0Worker *multi_proc_PVPV0WorkerList;
  multi_proc_PVPV0Impulse0 Impulse0;
  multi_proc_PVPV0Impulse1 Impulse1;
  multi_proc_PVPV0Impulse2 Impulse2;

  multi_proc_PVPV0(int timeindex=0);
  ~multi_proc_PVPV0();
  void CreateWorkerList(void);
};

#endif
