

// This C++ file was created by SanEditor

#include "Atomic/controllers/controllersSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         controllersSAN Constructor             
******************************************************************/


controllersSAN::controllersSAN(){


  Activity* InitialActionList[2]={
    &Ac_controller_repair, //0
    &Ac_controller_failure  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(Ac_controller_repair), 
    (BaseGroupClass*) &(Ac_controller_failure)
  };

  controllers_working = new Place("controllers_working" ,2);
  system_fail = new Place("system_fail" ,0);
  controllers_failed = new Place("controllers_failed" ,0);
  BaseStateVariableClass* InitialPlaces[3]={
    controllers_working,  // 0
    system_fail,  // 1
    controllers_failed   // 2
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("controllers", 3, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[6][2]={ 
    {2,0}, {0,0}, {1,0}, {0,1}, {2,1}, {1,1}
  };
  for(int n=0;n<6;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[2][2]={ 
    {2,0}, {0,1}
  };
  for(int n=0;n<2;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void controllersSAN::CustomInitialization() {

}
controllersSAN::~controllersSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void controllersSAN::assignPlacesToActivitiesInst(){
}
void controllersSAN::assignPlacesToActivitiesTimed(){
  Ac_controller_repair.controllers_failed = (Place*) LocalStateVariables[2];
  Ac_controller_repair.controllers_working = (Place*) LocalStateVariables[0];
  Ac_controller_repair.system_fail = (Place*) LocalStateVariables[1];
  Ac_controller_failure.controllers_working = (Place*) LocalStateVariables[0];
  Ac_controller_failure.controllers_failed = (Place*) LocalStateVariables[2];
  Ac_controller_failure.system_fail = (Place*) LocalStateVariables[1];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Ac_controller_repairActivity========================*/

controllersSAN::Ac_controller_repairActivity::Ac_controller_repairActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_controller_repair",0,Exponential, RaceEnabled, 3,1, false);
}

controllersSAN::Ac_controller_repairActivity::~Ac_controller_repairActivity(){
  delete[] TheDistributionParameters;
}

void controllersSAN::Ac_controller_repairActivity::LinkVariables(){
  controllers_failed->Register(&controllers_failed_Mobius_Mark);
  controllers_working->Register(&controllers_working_Mobius_Mark);
  system_fail->Register(&system_fail_Mobius_Mark);
}

bool controllersSAN::Ac_controller_repairActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(controllers_failed_Mobius_Mark)) >=1));
  return NewEnabled;
}

double controllersSAN::Ac_controller_repairActivity::Rate(){
  return 1.0;
  return 1.0;  // default rate if none is specified
}

double controllersSAN::Ac_controller_repairActivity::Weight(){ 
  return 1;
}

bool controllersSAN::Ac_controller_repairActivity::ReactivationPredicate(){ 
  return false;
}

bool controllersSAN::Ac_controller_repairActivity::ReactivationFunction(){ 
  return false;
}

double controllersSAN::Ac_controller_repairActivity::SampleDistribution(){
  return TheDistribution->Exponential(1.0);
}

double* controllersSAN::Ac_controller_repairActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int controllersSAN::Ac_controller_repairActivity::Rank(){
  return 1;
}

BaseActionClass* controllersSAN::Ac_controller_repairActivity::Fire(){
  (*(controllers_failed_Mobius_Mark))--;
  controllers_working->Mark()++;
if(controllers_working->Mark() == 1)
  system_fail->Mark()--;
  return this;
}

/*======================Ac_controller_failureActivity========================*/

controllersSAN::Ac_controller_failureActivity::Ac_controller_failureActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_controller_failure",1,Exponential, RaceEnabled, 3,1, false);
}

controllersSAN::Ac_controller_failureActivity::~Ac_controller_failureActivity(){
  delete[] TheDistributionParameters;
}

void controllersSAN::Ac_controller_failureActivity::LinkVariables(){
  controllers_working->Register(&controllers_working_Mobius_Mark);
  controllers_failed->Register(&controllers_failed_Mobius_Mark);
  system_fail->Register(&system_fail_Mobius_Mark);
}

bool controllersSAN::Ac_controller_failureActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(controllers_working_Mobius_Mark)) >=1));
  return NewEnabled;
}

double controllersSAN::Ac_controller_failureActivity::Rate(){
  return 1/2000.0 * 
controllers_working->Mark();
  return 1.0;  // default rate if none is specified
}

double controllersSAN::Ac_controller_failureActivity::Weight(){ 
  return 1;
}

bool controllersSAN::Ac_controller_failureActivity::ReactivationPredicate(){ 
  return false;
}

bool controllersSAN::Ac_controller_failureActivity::ReactivationFunction(){ 
  return false;
}

double controllersSAN::Ac_controller_failureActivity::SampleDistribution(){
  return TheDistribution->Exponential(Rate());
}

double* controllersSAN::Ac_controller_failureActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int controllersSAN::Ac_controller_failureActivity::Rank(){
  return 1;
}

BaseActionClass* controllersSAN::Ac_controller_failureActivity::Fire(){
  (*(controllers_working_Mobius_Mark))--;
  controllers_failed->Mark()++;
if(controllers_working->Mark() == 0)
  system_fail->Mark()++;
  return this;
}

