#ifndef controllersSAN_H_
#define controllersSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               controllersSAN Submodel Definition                   
*********************************************************************/

class controllersSAN:public SANModel{
public:

class Ac_controller_repairActivity:public Activity {
public:

  Place* controllers_failed;
  short* controllers_failed_Mobius_Mark;
  Place* controllers_working;
  short* controllers_working_Mobius_Mark;
  Place* system_fail;
  short* system_fail_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_controller_repairActivity();
  ~Ac_controller_repairActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_controller_repairActivityActivity

class Ac_controller_failureActivity:public Activity {
public:

  Place* controllers_working;
  short* controllers_working_Mobius_Mark;
  Place* controllers_failed;
  short* controllers_failed_Mobius_Mark;
  Place* system_fail;
  short* system_fail_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_controller_failureActivity();
  ~Ac_controller_failureActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_controller_failureActivityActivity

  //List of user-specified place names
  Place* controllers_working;
  Place* system_fail;
  Place* controllers_failed;

  // Create instances of all actvities
  Ac_controller_repairActivity Ac_controller_repair;
  Ac_controller_failureActivity Ac_controller_failure;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  controllersSAN();
  ~controllersSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end controllersSAN

#endif // controllersSAN_H_
