

// This C++ file was created by SanEditor

#include "Atomic/disks/disksSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         disksSAN Constructor             
******************************************************************/


disksSAN::disksSAN(){


  Activity* InitialActionList[2]={
    &Ac_disk_repair, //0
    &Ac_disk_failure  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(Ac_disk_repair), 
    (BaseGroupClass*) &(Ac_disk_failure)
  };

  disks_working = new Place("disks_working" ,4);
  disks_failed = new Place("disks_failed" ,0);
  system_fail = new Place("system_fail" ,0);
  BaseStateVariableClass* InitialPlaces[3]={
    disks_working,  // 0
    disks_failed,  // 1
    system_fail   // 2
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("disks", 3, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[6][2]={ 
    {1,0}, {0,0}, {2,0}, {0,1}, {1,1}, {2,1}
  };
  for(int n=0;n<6;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[2][2]={ 
    {1,0}, {0,1}
  };
  for(int n=0;n<2;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void disksSAN::CustomInitialization() {

}
disksSAN::~disksSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void disksSAN::assignPlacesToActivitiesInst(){
}
void disksSAN::assignPlacesToActivitiesTimed(){
  Ac_disk_repair.disks_failed = (Place*) LocalStateVariables[1];
  Ac_disk_repair.disks_working = (Place*) LocalStateVariables[0];
  Ac_disk_repair.system_fail = (Place*) LocalStateVariables[2];
  Ac_disk_failure.disks_working = (Place*) LocalStateVariables[0];
  Ac_disk_failure.disks_failed = (Place*) LocalStateVariables[1];
  Ac_disk_failure.system_fail = (Place*) LocalStateVariables[2];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Ac_disk_repairActivity========================*/

disksSAN::Ac_disk_repairActivity::Ac_disk_repairActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_disk_repair",0,Exponential, RaceEnabled, 3,1, false);
}

disksSAN::Ac_disk_repairActivity::~Ac_disk_repairActivity(){
  delete[] TheDistributionParameters;
}

void disksSAN::Ac_disk_repairActivity::LinkVariables(){
  disks_failed->Register(&disks_failed_Mobius_Mark);
  disks_working->Register(&disks_working_Mobius_Mark);
  system_fail->Register(&system_fail_Mobius_Mark);
}

bool disksSAN::Ac_disk_repairActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(disks_failed_Mobius_Mark)) >=1));
  return NewEnabled;
}

double disksSAN::Ac_disk_repairActivity::Rate(){
  return repair_rate;
  return 1.0;  // default rate if none is specified
}

double disksSAN::Ac_disk_repairActivity::Weight(){ 
  return 1;
}

bool disksSAN::Ac_disk_repairActivity::ReactivationPredicate(){ 
  return false;
}

bool disksSAN::Ac_disk_repairActivity::ReactivationFunction(){ 
  return false;
}

double disksSAN::Ac_disk_repairActivity::SampleDistribution(){
  return TheDistribution->Exponential(repair_rate);
}

double* disksSAN::Ac_disk_repairActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int disksSAN::Ac_disk_repairActivity::Rank(){
  return 1;
}

BaseActionClass* disksSAN::Ac_disk_repairActivity::Fire(){
  (*(disks_failed_Mobius_Mark))--;
  disks_working->Mark()++;
if (disks_working->Mark() == 3)
   system_fail->Mark()--;
  return this;
}

/*======================Ac_disk_failureActivity========================*/

disksSAN::Ac_disk_failureActivity::Ac_disk_failureActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_disk_failure",1,Exponential, RaceEnabled, 3,1, false);
}

disksSAN::Ac_disk_failureActivity::~Ac_disk_failureActivity(){
  delete[] TheDistributionParameters;
}

void disksSAN::Ac_disk_failureActivity::LinkVariables(){
  disks_working->Register(&disks_working_Mobius_Mark);
  disks_failed->Register(&disks_failed_Mobius_Mark);
  system_fail->Register(&system_fail_Mobius_Mark);
}

bool disksSAN::Ac_disk_failureActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(disks_working_Mobius_Mark)) >=1));
  return NewEnabled;
}

double disksSAN::Ac_disk_failureActivity::Rate(){
  return 1/6000.0 * disks_working->Mark();
  return 1.0;  // default rate if none is specified
}

double disksSAN::Ac_disk_failureActivity::Weight(){ 
  return 1;
}

bool disksSAN::Ac_disk_failureActivity::ReactivationPredicate(){ 
  return false;
}

bool disksSAN::Ac_disk_failureActivity::ReactivationFunction(){ 
  return false;
}

double disksSAN::Ac_disk_failureActivity::SampleDistribution(){
  return TheDistribution->Exponential(1/6000.0 * disks_working->Mark());
}

double* disksSAN::Ac_disk_failureActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int disksSAN::Ac_disk_failureActivity::Rank(){
  return 1;
}

BaseActionClass* disksSAN::Ac_disk_failureActivity::Fire(){
  (*(disks_working_Mobius_Mark))--;
  disks_failed->Mark()++;
if (disks_working->Mark() == 2)
   system_fail->Mark()++;
  return this;
}

