#ifndef disksSAN_H_
#define disksSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double repair_rate;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               disksSAN Submodel Definition                   
*********************************************************************/

class disksSAN:public SANModel{
public:

class Ac_disk_repairActivity:public Activity {
public:

  Place* disks_failed;
  short* disks_failed_Mobius_Mark;
  Place* disks_working;
  short* disks_working_Mobius_Mark;
  Place* system_fail;
  short* system_fail_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_disk_repairActivity();
  ~Ac_disk_repairActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_disk_repairActivityActivity

class Ac_disk_failureActivity:public Activity {
public:

  Place* disks_working;
  short* disks_working_Mobius_Mark;
  Place* disks_failed;
  short* disks_failed_Mobius_Mark;
  Place* system_fail;
  short* system_fail_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_disk_failureActivity();
  ~Ac_disk_failureActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_disk_failureActivityActivity

  //List of user-specified place names
  Place* disks_working;
  Place* disks_failed;
  Place* system_fail;

  // Create instances of all actvities
  Ac_disk_repairActivity Ac_disk_repair;
  Ac_disk_failureActivity Ac_disk_failure;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  disksSAN();
  ~disksSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end disksSAN

#endif // disksSAN_H_
