

// This C++ file was created by SanEditor

#include "Atomic/processors/processorsSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         processorsSAN Constructor             
******************************************************************/


processorsSAN::processorsSAN(){


  Activity* InitialActionList[2]={
    &Ac_processor_repair, //0
    &Ac_processor_failure  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(Ac_processor_repair), 
    (BaseGroupClass*) &(Ac_processor_failure)
  };

  processors_working = new Place("processors_working" ,2);
  processors_failed = new Place("processors_failed" ,0);
  system_fail = new Place("system_fail" ,0);
  BaseStateVariableClass* InitialPlaces[3]={
    processors_working,  // 0
    processors_failed,  // 1
    system_fail   // 2
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("processors", 3, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[6][2]={ 
    {1,0}, {0,0}, {2,0}, {0,1}, {1,1}, {2,1}
  };
  for(int n=0;n<6;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[2][2]={ 
    {1,0}, {0,1}
  };
  for(int n=0;n<2;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void processorsSAN::CustomInitialization() {

}
processorsSAN::~processorsSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void processorsSAN::assignPlacesToActivitiesInst(){
}
void processorsSAN::assignPlacesToActivitiesTimed(){
  Ac_processor_repair.processors_failed = (Place*) LocalStateVariables[1];
  Ac_processor_repair.processors_working = (Place*) LocalStateVariables[0];
  Ac_processor_repair.system_fail = (Place*) LocalStateVariables[2];
  Ac_processor_failure.processors_working = (Place*) LocalStateVariables[0];
  Ac_processor_failure.processors_failed = (Place*) LocalStateVariables[1];
  Ac_processor_failure.system_fail = (Place*) LocalStateVariables[2];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Ac_processor_repairActivity========================*/

processorsSAN::Ac_processor_repairActivity::Ac_processor_repairActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_processor_repair",0,Exponential, RaceEnabled, 3,1, false);
}

processorsSAN::Ac_processor_repairActivity::~Ac_processor_repairActivity(){
  delete[] TheDistributionParameters;
}

void processorsSAN::Ac_processor_repairActivity::LinkVariables(){
  processors_failed->Register(&processors_failed_Mobius_Mark);
  processors_working->Register(&processors_working_Mobius_Mark);
  system_fail->Register(&system_fail_Mobius_Mark);
}

bool processorsSAN::Ac_processor_repairActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(processors_failed_Mobius_Mark)) >=1));
  return NewEnabled;
}

double processorsSAN::Ac_processor_repairActivity::Rate(){
  return 1.0;
  return 1.0;  // default rate if none is specified
}

double processorsSAN::Ac_processor_repairActivity::Weight(){ 
  return 1;
}

bool processorsSAN::Ac_processor_repairActivity::ReactivationPredicate(){ 
  return false;
}

bool processorsSAN::Ac_processor_repairActivity::ReactivationFunction(){ 
  return false;
}

double processorsSAN::Ac_processor_repairActivity::SampleDistribution(){
  return TheDistribution->Exponential(1.0);
}

double* processorsSAN::Ac_processor_repairActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int processorsSAN::Ac_processor_repairActivity::Rank(){
  return 1;
}

BaseActionClass* processorsSAN::Ac_processor_repairActivity::Fire(){
  (*(processors_failed_Mobius_Mark))--;
  processors_working->Mark()++;
if(processors_working->Mark() == 1)
  system_fail->Mark()--;
  return this;
}

/*======================Ac_processor_failureActivity========================*/

processorsSAN::Ac_processor_failureActivity::Ac_processor_failureActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_processor_failure",1,Exponential, RaceEnabled, 3,1, false);
}

processorsSAN::Ac_processor_failureActivity::~Ac_processor_failureActivity(){
  delete[] TheDistributionParameters;
}

void processorsSAN::Ac_processor_failureActivity::LinkVariables(){
  processors_working->Register(&processors_working_Mobius_Mark);
  processors_failed->Register(&processors_failed_Mobius_Mark);
  system_fail->Register(&system_fail_Mobius_Mark);
}

bool processorsSAN::Ac_processor_failureActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(processors_working_Mobius_Mark)) >=1));
  return NewEnabled;
}

double processorsSAN::Ac_processor_failureActivity::Rate(){
  return 1/2000.0 * processors_working->Mark();
  return 1.0;  // default rate if none is specified
}

double processorsSAN::Ac_processor_failureActivity::Weight(){ 
  return 1;
}

bool processorsSAN::Ac_processor_failureActivity::ReactivationPredicate(){ 
  return false;
}

bool processorsSAN::Ac_processor_failureActivity::ReactivationFunction(){ 
  return false;
}

double processorsSAN::Ac_processor_failureActivity::SampleDistribution(){
  return TheDistribution->Exponential(1/2000.0 * processors_working->Mark());
}

double* processorsSAN::Ac_processor_failureActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int processorsSAN::Ac_processor_failureActivity::Rank(){
  return 1;
}

BaseActionClass* processorsSAN::Ac_processor_failureActivity::Fire(){
  (*(processors_working_Mobius_Mark))--;
  processors_failed->Mark()++;
if(processors_working->Mark() == 0)
  system_fail->Mark()++;
  return this;
}

