#ifndef processorsSAN_H_
#define processorsSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               processorsSAN Submodel Definition                   
*********************************************************************/

class processorsSAN:public SANModel{
public:

class Ac_processor_repairActivity:public Activity {
public:

  Place* processors_failed;
  short* processors_failed_Mobius_Mark;
  Place* processors_working;
  short* processors_working_Mobius_Mark;
  Place* system_fail;
  short* system_fail_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_processor_repairActivity();
  ~Ac_processor_repairActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_processor_repairActivityActivity

class Ac_processor_failureActivity:public Activity {
public:

  Place* processors_working;
  short* processors_working_Mobius_Mark;
  Place* processors_failed;
  short* processors_failed_Mobius_Mark;
  Place* system_fail;
  short* system_fail_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_processor_failureActivity();
  ~Ac_processor_failureActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_processor_failureActivityActivity

  //List of user-specified place names
  Place* processors_working;
  Place* processors_failed;
  Place* system_fail;

  // Create instances of all actvities
  Ac_processor_repairActivity Ac_processor_repair;
  Ac_processor_failureActivity Ac_processor_failure;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  processorsSAN();
  ~processorsSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end processorsSAN

#endif // processorsSAN_H_
