#ifndef busSAN_H_
#define busSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               busSAN Submodel Definition                   
*********************************************************************/

class busSAN:public SANModel{
public:

class Ac_prop_delayActivity:public Activity {
public:

  Place* channel;
  short* channel_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_prop_delayActivity();
  ~Ac_prop_delayActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_prop_delayActivityActivity

  //List of user-specified place names
  Place* channel;

  // Create instances of all actvities
  Ac_prop_delayActivity Ac_prop_delay;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  busSAN();
  ~busSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end busSAN

#endif // busSAN_H_
