

// This C++ file was created by SanEditor

#include "Atomic/station/stationSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         stationSAN Constructor             
******************************************************************/


stationSAN::stationSAN(){


  Activity* InitialActionList[3]={
    &Ac_finish, //0
    &Ac_access, //1
    &Ac_arrival  // 2
  };

  BaseGroupClass* InitialGroupList[3]={
    (BaseGroupClass*) &(Ac_finish), 
    (BaseGroupClass*) &(Ac_access), 
    (BaseGroupClass*) &(Ac_arrival)
  };

  A = new Place("A" ,1);
  channel = new Place("channel" ,0);
  C = new Place("C" ,1);
  B = new Place("B" ,0);
  BaseStateVariableClass* InitialPlaces[4]={
    A,  // 0
    channel,  // 1
    C,  // 2
    B   // 3
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("station", 4, InitialPlaces, 
                        0, InitialROPlaces, 
                        3, InitialActionList, 3, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[8][2]={ 
    {3,0}, {2,0}, {1,0}, {2,1}, {0,1}, {1,1}, {3,1}, {0,2}
  };
  for(int n=0;n<8;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[5][2]={ 
    {3,0}, {1,0}, {2,1}, {0,1}, {0,2}
  };
  for(int n=0;n<5;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<3;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void stationSAN::CustomInitialization() {

}
stationSAN::~stationSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void stationSAN::assignPlacesToActivitiesInst(){
}
void stationSAN::assignPlacesToActivitiesTimed(){
  Ac_finish.B = (Place*) LocalStateVariables[3];
  Ac_finish.channel = (Place*) LocalStateVariables[1];
  Ac_finish.C = (Place*) LocalStateVariables[2];
  Ac_access.C = (Place*) LocalStateVariables[2];
  Ac_access.A = (Place*) LocalStateVariables[0];
  Ac_access.channel = (Place*) LocalStateVariables[1];
  Ac_access.B = (Place*) LocalStateVariables[3];
  Ac_arrival.A = (Place*) LocalStateVariables[0];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Ac_finishActivity========================*/

stationSAN::Ac_finishActivity::Ac_finishActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_finish",0,Exponential, RaceEnabled, 3,2, false);
}

stationSAN::Ac_finishActivity::~Ac_finishActivity(){
  delete[] TheDistributionParameters;
}

void stationSAN::Ac_finishActivity::LinkVariables(){
  B->Register(&B_Mobius_Mark);
  channel->Register(&channel_Mobius_Mark);
  C->Register(&C_Mobius_Mark);
}

bool stationSAN::Ac_finishActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(B_Mobius_Mark)) >=1)&&(channel->Mark()==2 || channel->Mark()==3));
  return NewEnabled;
}

double stationSAN::Ac_finishActivity::Rate(){
  if (channel->Mark()==2) 
   return(1.0);
else 
   return(5.0);
  return 1.0;  // default rate if none is specified
}

double stationSAN::Ac_finishActivity::Weight(){ 
  return 1;
}

bool stationSAN::Ac_finishActivity::ReactivationPredicate(){ 
  return false;
}

bool stationSAN::Ac_finishActivity::ReactivationFunction(){ 
  return false;
}

double stationSAN::Ac_finishActivity::SampleDistribution(){
  return TheDistribution->Exponential(Rate());
}

double* stationSAN::Ac_finishActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int stationSAN::Ac_finishActivity::Rank(){
  return 1;
}

BaseActionClass* stationSAN::Ac_finishActivity::Fire(){
  channel->Mark()=0;
  (*(B_Mobius_Mark))--;
  (*(C_Mobius_Mark))++;
  return this;
}

/*======================Ac_accessActivity========================*/

stationSAN::Ac_accessActivity::Ac_accessActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_access",1,Exponential, RaceEnabled, 4,2, false);
}

stationSAN::Ac_accessActivity::~Ac_accessActivity(){
  delete[] TheDistributionParameters;
}

void stationSAN::Ac_accessActivity::LinkVariables(){
  C->Register(&C_Mobius_Mark);
  A->Register(&A_Mobius_Mark);
  channel->Register(&channel_Mobius_Mark);
  B->Register(&B_Mobius_Mark);
}

bool stationSAN::Ac_accessActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(C_Mobius_Mark)) >=1)&&((*(A_Mobius_Mark)) >=1));
  return NewEnabled;
}

double stationSAN::Ac_accessActivity::Rate(){
  return accessrate;
  return 1.0;  // default rate if none is specified
}

double stationSAN::Ac_accessActivity::Weight(){ 
  return 1;
}

bool stationSAN::Ac_accessActivity::ReactivationPredicate(){ 
  return false;
}

bool stationSAN::Ac_accessActivity::ReactivationFunction(){ 
  return false;
}

double stationSAN::Ac_accessActivity::SampleDistribution(){
  return TheDistribution->Exponential(accessrate);
}

double* stationSAN::Ac_accessActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int stationSAN::Ac_accessActivity::Rank(){
  return 1;
}

BaseActionClass* stationSAN::Ac_accessActivity::Fire(){
  (*(C_Mobius_Mark))--;
  (*(A_Mobius_Mark))--;
  if (channel->Mark()==0) {
   channel->Mark()=1; B->Mark()=1; }
else if (channel->Mark()==1) {
   channel->Mark()=3; C->Mark()=1; A->Mark()++; }
else if (channel->Mark()==2) {
   C->Mark()=1; A->Mark()++; }
else if (channel->Mark()==3) {
   C->Mark()=1; A->Mark()++; }
  return this;
}

/*======================Ac_arrivalActivity========================*/

stationSAN::Ac_arrivalActivity::Ac_arrivalActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_arrival",2,Exponential, RaceEnabled, 1,1, false);
}

stationSAN::Ac_arrivalActivity::~Ac_arrivalActivity(){
  delete[] TheDistributionParameters;
}

void stationSAN::Ac_arrivalActivity::LinkVariables(){
  A->Register(&A_Mobius_Mark);
}

bool stationSAN::Ac_arrivalActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((A->Mark()<2));
  return NewEnabled;
}

double stationSAN::Ac_arrivalActivity::Rate(){
  return arrivalrate;
  return 1.0;  // default rate if none is specified
}

double stationSAN::Ac_arrivalActivity::Weight(){ 
  return 1;
}

bool stationSAN::Ac_arrivalActivity::ReactivationPredicate(){ 
  return false;
}

bool stationSAN::Ac_arrivalActivity::ReactivationFunction(){ 
  return false;
}

double stationSAN::Ac_arrivalActivity::SampleDistribution(){
  return TheDistribution->Exponential(arrivalrate);
}

double* stationSAN::Ac_arrivalActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int stationSAN::Ac_arrivalActivity::Rank(){
  return 1;
}

BaseActionClass* stationSAN::Ac_arrivalActivity::Fire(){
  ;
  (*(A_Mobius_Mark))++;
  return this;
}

