#ifndef stationSAN_H_
#define stationSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double arrivalrate;
extern short accessrate;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               stationSAN Submodel Definition                   
*********************************************************************/

class stationSAN:public SANModel{
public:

class Ac_finishActivity:public Activity {
public:

  Place* B;
  short* B_Mobius_Mark;
  Place* channel;
  short* channel_Mobius_Mark;
  Place* C;
  short* C_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_finishActivity();
  ~Ac_finishActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_finishActivityActivity

class Ac_accessActivity:public Activity {
public:

  Place* C;
  short* C_Mobius_Mark;
  Place* A;
  short* A_Mobius_Mark;
  Place* channel;
  short* channel_Mobius_Mark;
  Place* B;
  short* B_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_accessActivity();
  ~Ac_accessActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_accessActivityActivity

class Ac_arrivalActivity:public Activity {
public:

  Place* A;
  short* A_Mobius_Mark;

  double* TheDistributionParameters;
  Ac_arrivalActivity();
  ~Ac_arrivalActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Ac_arrivalActivityActivity

  //List of user-specified place names
  Place* A;
  Place* channel;
  Place* C;
  Place* B;

  // Create instances of all actvities
  Ac_finishActivity Ac_finish;
  Ac_accessActivity Ac_access;
  Ac_arrivalActivity Ac_arrival;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  stationSAN();
  ~stationSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end stationSAN

#endif // stationSAN_H_
