#include "Composed/lan2/lan2RJ__Rep1.h"
char * lan2RJ__Rep1__SharedNames[] = {"channel"};

lan2RJ__Rep1::lan2RJ__Rep1():Rep("Rep1", 5, 1, lan2RJ__Rep1__SharedNames)
{
  InstanceArray = new stationSAN * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new stationSAN();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    channel = new Place("channel");
    addSharedPtr(channel, "channel");
    channel->ShareWith(InstanceArray[0]->channel);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->channel, channel);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->channel->ShareWith(InstanceArray[counter]->channel);
    }
  }
  Setup("station");
}

lan2RJ__Rep1::~lan2RJ__Rep1() {
  if (NumModels == 0) return;
  delete channel;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

