#include "lan_rewardPVNodes.h"

lan_rewardPV0Worker::lan_rewardPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&bus);
}

lan_rewardPV0Worker::~lan_rewardPV0Worker() {
  delete [] TheModelPtr;
}

double lan_rewardPV0Worker::Reward_Function(void) {

if(bus->channel->Mark()==0){
 return 1;
}
else{
  return 0;
}

return (0);



}

lan_rewardPV0::lan_rewardPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Thelan2RJ);
  double startpts[1]={1.0};
  double stoppts[1]={1.0};
  Initialize("probability_idle",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("channel","bus");
}

lan_rewardPV0::~lan_rewardPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void lan_rewardPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new lan_rewardPV0Worker;
}
lan_rewardPV1Worker::lan_rewardPV1Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&bus);
}

lan_rewardPV1Worker::~lan_rewardPV1Worker() {
  delete [] TheModelPtr;
}

double lan_rewardPV1Worker::Reward_Function(void) {

if(bus->channel->Mark()==1){
  return 1;
}
else{
  return 0;
}

return (0);



}

lan_rewardPV1::lan_rewardPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Thelan2RJ);
  double startpts[1]={1.0};
  double stoppts[1]={1.0};
  Initialize("probability_unpropagated",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("channel","bus");
}

lan_rewardPV1::~lan_rewardPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void lan_rewardPV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new lan_rewardPV1Worker;
}
lan_rewardPV2Worker::lan_rewardPV2Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&bus);
}

lan_rewardPV2Worker::~lan_rewardPV2Worker() {
  delete [] TheModelPtr;
}

double lan_rewardPV2Worker::Reward_Function(void) {

if(bus->channel->Mark()==2){
   return 1;
}
else{
   return 0;
}

return (0);



}

lan_rewardPV2::lan_rewardPV2(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Thelan2RJ);
  double startpts[1]={1.0};
  double stoppts[1]={1.0};
  Initialize("utilization",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("channel","bus");
}

lan_rewardPV2::~lan_rewardPV2() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void lan_rewardPV2::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new lan_rewardPV2Worker;
}
lan_rewardPV3Worker::lan_rewardPV3Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&station);
}

lan_rewardPV3Worker::~lan_rewardPV3Worker() {
  delete [] TheModelPtr;
}

double lan_rewardPV3Worker::Reward_Function(void) {

return station->A->Mark();

return (0);



}

lan_rewardPV3::lan_rewardPV3(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Thelan2RJ);
  double startpts[1]={1.0};
  double stoppts[1]={1.0};
  Initialize("queue_length",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("A","station");
}

lan_rewardPV3::~lan_rewardPV3() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void lan_rewardPV3::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new lan_rewardPV3Worker;
}
lan_rewardPV4Worker::lan_rewardPV4Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&bus);
}

lan_rewardPV4Worker::~lan_rewardPV4Worker() {
  delete [] TheModelPtr;
}

double lan_rewardPV4Worker::Reward_Function(void) {

if(bus->channel->Mark()==3){
  return 1;
}
else{
  return 0;
}

return (0);



}

lan_rewardPV4::lan_rewardPV4(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Thelan2RJ);
  double startpts[1]={1.0};
  double stoppts[1]={1.0};
  Initialize("probability_collision",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("channel","bus");
}

lan_rewardPV4::~lan_rewardPV4() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void lan_rewardPV4::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new lan_rewardPV4Worker;
}
