#ifndef _LAN_REWARD_PVS_
#define _LAN_REWARD_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/lan2/lan2RJ__Rep1.h"
#include "Composed/lan2/lan2RJ.h"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"


class lan_rewardPV0Worker:public InstantOfTime
{
 public:
  busSAN *bus;
  
  lan_rewardPV0Worker();
  ~lan_rewardPV0Worker();
  double Reward_Function();
};

class lan_rewardPV0:public PerformanceVariableNode
{
 public:
  lan2RJ *Thelan2RJ;

  lan_rewardPV0Worker *lan_rewardPV0WorkerList;

  lan_rewardPV0(int timeindex=0);
  ~lan_rewardPV0();
  void CreateWorkerList(void);
};

class lan_rewardPV1Worker:public InstantOfTime
{
 public:
  busSAN *bus;
  
  lan_rewardPV1Worker();
  ~lan_rewardPV1Worker();
  double Reward_Function();
};

class lan_rewardPV1:public PerformanceVariableNode
{
 public:
  lan2RJ *Thelan2RJ;

  lan_rewardPV1Worker *lan_rewardPV1WorkerList;

  lan_rewardPV1(int timeindex=0);
  ~lan_rewardPV1();
  void CreateWorkerList(void);
};

class lan_rewardPV2Worker:public InstantOfTime
{
 public:
  busSAN *bus;
  
  lan_rewardPV2Worker();
  ~lan_rewardPV2Worker();
  double Reward_Function();
};

class lan_rewardPV2:public PerformanceVariableNode
{
 public:
  lan2RJ *Thelan2RJ;

  lan_rewardPV2Worker *lan_rewardPV2WorkerList;

  lan_rewardPV2(int timeindex=0);
  ~lan_rewardPV2();
  void CreateWorkerList(void);
};

class lan_rewardPV3Worker:public InstantOfTime
{
 public:
  stationSAN *station;
  
  lan_rewardPV3Worker();
  ~lan_rewardPV3Worker();
  double Reward_Function();
};

class lan_rewardPV3:public PerformanceVariableNode
{
 public:
  lan2RJ *Thelan2RJ;

  lan_rewardPV3Worker *lan_rewardPV3WorkerList;

  lan_rewardPV3(int timeindex=0);
  ~lan_rewardPV3();
  void CreateWorkerList(void);
};

class lan_rewardPV4Worker:public InstantOfTime
{
 public:
  busSAN *bus;
  
  lan_rewardPV4Worker();
  ~lan_rewardPV4Worker();
  double Reward_Function();
};

class lan_rewardPV4:public PerformanceVariableNode
{
 public:
  lan2RJ *Thelan2RJ;

  lan_rewardPV4Worker *lan_rewardPV4WorkerList;

  lan_rewardPV4(int timeindex=0);
  ~lan_rewardPV4();
  void CreateWorkerList(void);
};

#endif
